/*     */ package com.google.code.yanf4j.nio.impl;
/*     */ 
/*     */ import com.google.code.yanf4j.config.Configuration;
/*     */ import com.google.code.yanf4j.core.EventType;
/*     */ import com.google.code.yanf4j.core.Session;
/*     */ import com.google.code.yanf4j.nio.NioSession;
/*     */ import com.google.code.yanf4j.statistics.Statistics;
/*     */ import com.google.code.yanf4j.util.LinkedTransferQueue;
/*     */ import com.google.code.yanf4j.util.SystemUtils;
/*     */ import java.io.IOException;
/*     */ import java.nio.channels.CancelledKeyException;
/*     */ import java.nio.channels.ClosedChannelException;
/*     */ import java.nio.channels.ClosedSelectorException;
/*     */ import java.nio.channels.SelectableChannel;
/*     */ import java.nio.channels.SelectionKey;
/*     */ import java.nio.channels.Selector;
/*     */ import java.util.Date;
/*     */ import java.util.Iterator;
/*     */ import java.util.Queue;
/*     */ import java.util.Set;
/*     */ import java.util.concurrent.RejectedExecutionException;
/*     */ import java.util.concurrent.atomic.AtomicBoolean;
/*     */ import java.util.concurrent.atomic.AtomicInteger;
/*     */ import java.util.concurrent.locks.Lock;
/*     */ import java.util.concurrent.locks.ReentrantLock;
/*     */ import org.slf4j.Logger;
/*     */ import org.slf4j.LoggerFactory;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class Reactor
/*     */   extends Thread
/*     */ {
/*  44 */   public static final int JVMBUG_THRESHHOLD = Integer.getInteger("com.googlecode.yanf4j.nio.JVMBUG_THRESHHOLD", 128).intValue();
/*     */   
/*  46 */   public static final int JVMBUG_THRESHHOLD2 = JVMBUG_THRESHHOLD * 2;
/*  47 */   public static final int JVMBUG_THRESHHOLD1 = (JVMBUG_THRESHHOLD2 + JVMBUG_THRESHHOLD) / 2;
/*     */   
/*     */   public static final int DEFAULT_WAIT = 1000;
/*  50 */   private static final Logger log = LoggerFactory.getLogger("remoting");
/*     */   
/*     */   private boolean jvmBug0;
/*     */   
/*     */   private boolean jvmBug1;
/*     */   
/*     */   private final int reactorIndex;
/*     */   
/*     */   private final SelectorManager selectorManager;
/*  59 */   private final AtomicInteger jvmBug = new AtomicInteger(0);
/*     */   
/*     */   private long lastJVMBug;
/*     */   
/*     */   private volatile Selector selector;
/*     */   
/*     */   private final NioController controller;
/*     */   
/*     */   private final Configuration configuration;
/*     */   
/*  69 */   private final AtomicBoolean wakenUp = new AtomicBoolean(false);
/*     */   
/*  71 */   private final Queue<Object[]> register = new LinkedTransferQueue();
/*     */   
/*  73 */   private final Lock gate = new ReentrantLock();
/*     */   
/*  75 */   private volatile int selectTries = 0;
/*     */   
/*  77 */   private long nextTimeout = 0L;
/*     */   
/*     */   Reactor(SelectorManager selectorManager, Configuration configuration, int index)
/*     */     throws IOException
/*     */   {
/*  82 */     this.reactorIndex = index;
/*  83 */     this.selectorManager = selectorManager;
/*  84 */     this.controller = selectorManager.getController();
/*  85 */     this.selector = SystemUtils.openSelector();
/*  86 */     this.configuration = configuration;
/*  87 */     setName("Xmemcached-Reactor-" + index);
/*     */   }
/*     */   
/*     */   public final Selector getSelector() {
/*  91 */     return this.selector;
/*     */   }
/*     */   
/*     */   public int getReactorIndex() {
/*  95 */     return this.reactorIndex;
/*     */   }
/*     */   
/*     */   public void run()
/*     */   {
/* 100 */     this.selectorManager.notifyReady();
/* 101 */     while ((this.selectorManager.isStarted()) && (this.selector.isOpen())) {
/*     */       try {
/* 103 */         beforeSelect();
/* 104 */         this.wakenUp.set(false);
/* 105 */         long before = -1L;
/*     */         
/* 107 */         if (isNeedLookingJVMBug()) {
/* 108 */           before = System.currentTimeMillis();
/*     */         }
/* 110 */         long wait = 1000L;
/* 111 */         if (this.nextTimeout > 0L) {
/* 112 */           wait = this.nextTimeout;
/*     */         }
/* 114 */         int selected = this.selector.select(wait);
/* 115 */         if (selected == 0) {
/* 116 */           if (before != -1L) {
/* 117 */             lookJVMBug(before, selected, wait);
/*     */           }
/* 119 */           this.selectTries += 1;
/*     */           
/* 121 */           this.nextTimeout = checkSessionTimeout();
/* 122 */           continue;
/*     */         }
/* 124 */         this.selectTries = 0;
/*     */       }
/*     */       catch (ClosedSelectorException e) {
/*     */         break;
/*     */       }
/*     */       catch (IOException e) {
/* 130 */         log.error("Reactor select error", e); }
/* 131 */       if (!this.selector.isOpen())
/*     */       {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 137 */         break;Set<SelectionKey> selectedKeys = this.selector.selectedKeys();
/* 138 */         this.gate.lock();
/*     */         try {
/* 140 */           postSelect(selectedKeys, this.selector.keys());
/* 141 */           dispatchEvent(selectedKeys);
/*     */         } finally {
/* 143 */           this.gate.unlock();
/*     */         }
/*     */       } }
/* 146 */     if ((this.selector != null) && 
/* 147 */       (this.selector.isOpen())) {
/*     */       try {
/* 149 */         this.controller.closeChannel(this.selector);
/* 150 */         this.selector.close();
/*     */       } catch (IOException e) {
/* 152 */         this.controller.notifyException(e);
/* 153 */         log.error("stop reactor error", e);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private boolean lookJVMBug(long before, int selected, long wait)
/*     */     throws IOException
/*     */   {
/* 171 */     boolean seeing = false;
/* 172 */     long now = System.currentTimeMillis();
/*     */     
/* 174 */     if ((JVMBUG_THRESHHOLD > 0) && (selected == 0) && (wait > JVMBUG_THRESHHOLD) && (now - before < wait / 4L) && (!this.wakenUp.get()) && (!Thread.currentThread().isInterrupted()))
/*     */     {
/*     */ 
/* 177 */       this.jvmBug.incrementAndGet();
/* 178 */       if (this.jvmBug.get() >= JVMBUG_THRESHHOLD2) {
/* 179 */         this.gate.lock();
/*     */         try {
/* 181 */           this.lastJVMBug = now;
/* 182 */           log.warn("JVM bug occured at " + new Date(this.lastJVMBug) + ",http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=6403933,reactIndex=" + this.reactorIndex);
/*     */           
/*     */ 
/*     */ 
/*     */ 
/* 187 */           if (this.jvmBug1) {
/* 188 */             log.debug("seeing JVM BUG(s) - recreating selector,reactIndex=" + this.reactorIndex);
/*     */           }
/*     */           else
/*     */           {
/* 192 */             this.jvmBug1 = true;
/* 193 */             log.info("seeing JVM BUG(s) - recreating selector,reactIndex=" + this.reactorIndex);
/*     */           }
/*     */           
/*     */ 
/* 197 */           seeing = true;
/* 198 */           Selector new_selector = SystemUtils.openSelector();
/*     */           
/* 200 */           for (SelectionKey k : this.selector.keys()) {
/* 201 */             if ((k.isValid()) && (k.interestOps() != 0))
/*     */             {
/*     */ 
/*     */ 
/* 205 */               SelectableChannel channel = k.channel();
/* 206 */               Object attachment = k.attachment();
/*     */               
/* 208 */               channel.register(new_selector, k.interestOps(), attachment);
/*     */             }
/*     */           }
/*     */           
/* 212 */           this.selector.close();
/* 213 */           this.selector = new_selector;
/*     */         }
/*     */         finally {
/* 216 */           this.gate.unlock();
/*     */         }
/* 218 */         this.jvmBug.set(0);
/*     */       }
/* 220 */       else if ((this.jvmBug.get() == JVMBUG_THRESHHOLD) || (this.jvmBug.get() == JVMBUG_THRESHHOLD1))
/*     */       {
/* 222 */         if (this.jvmBug0) {
/* 223 */           log.debug("seeing JVM BUG(s) - cancelling interestOps==0,reactIndex=" + this.reactorIndex);
/*     */         }
/*     */         else
/*     */         {
/* 227 */           this.jvmBug0 = true;
/* 228 */           log.info("seeing JVM BUG(s) - cancelling interestOps==0,reactIndex=" + this.reactorIndex);
/*     */         }
/*     */         
/*     */ 
/* 232 */         this.gate.lock();
/* 233 */         seeing = true;
/*     */         try {
/* 235 */           for (SelectionKey k : this.selector.keys()) {
/* 236 */             if ((k.isValid()) && (k.interestOps() == 0)) {
/* 237 */               k.cancel();
/*     */             }
/*     */           }
/*     */         } finally {
/* 241 */           this.gate.unlock();
/*     */         }
/*     */       }
/*     */     } else {
/* 245 */       this.jvmBug.set(0);
/*     */     }
/* 247 */     return seeing;
/*     */   }
/*     */   
/*     */   private boolean isNeedLookingJVMBug() {
/* 251 */     return (SystemUtils.isLinuxPlatform()) && (!SystemUtils.isAfterJava6u4Version());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final void dispatchEvent(Set<SelectionKey> selectedKeySet)
/*     */   {
/* 261 */     Iterator<SelectionKey> it = selectedKeySet.iterator();
/* 262 */     boolean skipOpRead = false;
/* 263 */     while (it.hasNext()) {
/* 264 */       SelectionKey key = (SelectionKey)it.next();
/* 265 */       it.remove();
/* 266 */       if (!key.isValid()) {
/* 267 */         if (key.attachment() != null) {
/* 268 */           this.controller.closeSelectionKey(key);
/*     */         } else {
/* 270 */           key.cancel();
/*     */         }
/*     */       }
/*     */       else {
/*     */         try {
/* 275 */           if ((key.isValid()) && (key.isAcceptable())) {
/* 276 */             this.controller.onAccept(key);
/* 277 */             continue;
/*     */           }
/* 279 */           if ((key.isValid()) && ((key.readyOps() & 0x4) == 4))
/*     */           {
/*     */ 
/* 282 */             key.interestOps(key.interestOps() & 0xFFFFFFFB);
/* 283 */             this.controller.onWrite(key);
/* 284 */             if (!this.controller.isHandleReadWriteConcurrently()) {
/* 285 */               skipOpRead = true;
/*     */             }
/*     */           }
/* 288 */           if ((!skipOpRead) && (key.isValid()) && ((key.readyOps() & 0x1) == 1))
/*     */           {
/*     */ 
/* 291 */             key.interestOps(key.interestOps() & 0xFFFFFFFE);
/* 292 */             if (!this.controller.getStatistics().isReceiveOverFlow())
/*     */             {
/* 294 */               this.controller.onRead(key);
/*     */             } else {
/* 296 */               key.interestOps(key.interestOps() | 0x1);
/*     */             }
/*     */           }
/*     */           
/*     */ 
/* 301 */           if ((key.readyOps() & 0x8) == 8) {
/* 302 */             this.controller.onConnect(key);
/*     */           }
/*     */           
/*     */ 
/*     */         }
/*     */         catch (CancelledKeyException e) {}catch (RejectedExecutionException e)
/*     */         {
/* 309 */           if ((key.attachment() instanceof AbstractNioSession)) {
/* 310 */             ((AbstractNioSession)key.attachment()).onException(e);
/*     */           }
/* 312 */           this.controller.notifyException(e);
/* 313 */           if (this.selector.isOpen()) {
/*     */             continue;
/*     */           }
/* 316 */           break;
/*     */         }
/*     */         catch (Exception e) {
/* 319 */           if ((key.attachment() instanceof AbstractNioSession)) {
/* 320 */             ((AbstractNioSession)key.attachment()).onException(e);
/*     */           }
/* 322 */           this.controller.closeSelectionKey(key);
/* 323 */           this.controller.notifyException(e);
/* 324 */           log.error("Reactor dispatch events error", e); }
/* 325 */         if (!this.selector.isOpen()) {
/*     */           break;
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   final void unregisterChannel(SelectableChannel channel)
/*     */     throws IOException
/*     */   {
/* 335 */     Selector selector = this.selector;
/* 336 */     if ((selector != null) && 
/* 337 */       (channel != null)) {
/* 338 */       SelectionKey key = channel.keyFor(selector);
/* 339 */       if (key != null) {
/* 340 */         key.cancel();
/*     */       }
/*     */     }
/*     */     
/* 344 */     wakeup();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private final long checkSessionTimeout()
/*     */   {
/* 353 */     long nextTimeout = 0L;
/* 354 */     if (this.configuration.getCheckSessionTimeoutInterval() > 0L) {
/* 355 */       this.gate.lock();
/*     */       try {
/* 357 */         if (this.selectTries * 1000 >= this.configuration.getCheckSessionTimeoutInterval())
/*     */         {
/* 359 */           nextTimeout = this.configuration.getCheckSessionTimeoutInterval();
/*     */           
/* 361 */           for (SelectionKey key : this.selector.keys())
/*     */           {
/* 363 */             if (key.attachment() != null) {
/* 364 */               long n = checkExpiredIdle(key, getSessionFromAttchment(key));
/*     */               
/* 366 */               nextTimeout = n < nextTimeout ? n : nextTimeout;
/*     */             }
/*     */           }
/* 369 */           this.selectTries = 0;
/*     */         }
/*     */       } finally {
/* 372 */         this.gate.unlock();
/*     */       }
/*     */     }
/* 375 */     return nextTimeout;
/*     */   }
/*     */   
/*     */   private final Session getSessionFromAttchment(SelectionKey key) {
/* 379 */     if ((key.attachment() instanceof Session)) {
/* 380 */       return (Session)key.attachment();
/*     */     }
/* 382 */     return null;
/*     */   }
/*     */   
/*     */   public final void registerSession(Session session, EventType event) {
/* 386 */     Selector selector = this.selector;
/* 387 */     if ((isReactorThread()) && (selector != null)) {
/* 388 */       dispatchSessionEvent(session, event, selector);
/*     */     } else {
/* 390 */       this.register.offer(new Object[] { session, event });
/* 391 */       wakeup();
/*     */     }
/*     */   }
/*     */   
/*     */   private final boolean isReactorThread() {
/* 396 */     return Thread.currentThread() == this;
/*     */   }
/*     */   
/*     */   final void beforeSelect() {
/* 400 */     this.controller.checkStatisticsForRestart();
/* 401 */     processRegister();
/*     */   }
/*     */   
/*     */   private final void processRegister() {
/* 405 */     Object[] object = null;
/* 406 */     while ((object = (Object[])this.register.poll()) != null) {
/* 407 */       switch (object.length) {
/*     */       case 2: 
/* 409 */         dispatchSessionEvent((Session)object[0], (EventType)object[1], this.selector);
/*     */         
/* 411 */         break;
/*     */       case 3: 
/* 413 */         registerChannelNow((SelectableChannel)object[0], ((Integer)object[1]).intValue(), object[2], this.selector);
/*     */       }
/*     */       
/*     */     }
/*     */   }
/*     */   
/*     */   Configuration getConfiguration()
/*     */   {
/* 421 */     return this.configuration;
/*     */   }
/*     */   
/*     */   private final void dispatchSessionEvent(Session session, EventType event, Selector selector)
/*     */   {
/* 426 */     if ((session.isClosed()) && (event != EventType.UNREGISTER)) {
/* 427 */       return;
/*     */     }
/* 429 */     if (EventType.REGISTER.equals(event)) {
/* 430 */       this.controller.registerSession(session);
/* 431 */     } else if (EventType.UNREGISTER.equals(event)) {
/* 432 */       this.controller.unregisterSession(session);
/*     */     } else {
/* 434 */       ((NioSession)session).onEvent(event, selector);
/*     */     }
/*     */   }
/*     */   
/*     */   public final void postSelect(Set<SelectionKey> selectedKeys, Set<SelectionKey> allKeys)
/*     */   {
/* 440 */     if ((this.controller.getSessionTimeout() > 0L) || (this.controller.getSessionIdleTimeout() > 0L))
/*     */     {
/* 442 */       for (SelectionKey key : allKeys)
/*     */       {
/* 444 */         if ((!selectedKeys.contains(key)) && 
/* 445 */           (key.attachment() != null)) {
/* 446 */           checkExpiredIdle(key, getSessionFromAttchment(key));
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   private long checkExpiredIdle(SelectionKey key, Session session)
/*     */   {
/* 454 */     if (session == null) {
/* 455 */       return 0L;
/*     */     }
/* 457 */     long nextTimeout = 0L;
/* 458 */     boolean expired = false;
/* 459 */     if (this.controller.getSessionTimeout() > 0L) {
/* 460 */       expired = checkExpired(key, session);
/* 461 */       nextTimeout = this.controller.getSessionTimeout();
/*     */     }
/* 463 */     if ((this.controller.getSessionIdleTimeout() > 0L) && (!expired)) {
/* 464 */       checkIdle(session);
/* 465 */       nextTimeout = this.controller.getSessionIdleTimeout();
/*     */     }
/* 467 */     return nextTimeout;
/*     */   }
/*     */   
/*     */   private final void checkIdle(Session session) {
/* 471 */     if ((this.controller.getSessionIdleTimeout() > 0L) && 
/* 472 */       (session.isIdle())) {
/* 473 */       ((NioSession)session).onEvent(EventType.IDLE, this.selector);
/*     */     }
/*     */   }
/*     */   
/*     */   private final boolean checkExpired(SelectionKey key, Session session)
/*     */   {
/* 479 */     if ((session != null) && (session.isExpired())) {
/* 480 */       ((NioSession)session).onEvent(EventType.EXPIRED, this.selector);
/* 481 */       this.controller.closeSelectionKey(key);
/* 482 */       return true;
/*     */     }
/* 484 */     return false;
/*     */   }
/*     */   
/*     */   public final void registerChannel(SelectableChannel channel, int ops, Object attachment)
/*     */   {
/* 489 */     Selector selector = this.selector;
/* 490 */     if ((isReactorThread()) && (selector != null)) {
/* 491 */       registerChannelNow(channel, ops, attachment, selector);
/*     */     } else {
/* 493 */       this.register.offer(new Object[] { channel, Integer.valueOf(ops), attachment });
/* 494 */       wakeup();
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   private void registerChannelNow(SelectableChannel channel, int ops, Object attachment, Selector selector)
/*     */   {
/* 501 */     this.gate.lock();
/*     */     try {
/* 503 */       if (channel.isOpen()) {
/* 504 */         channel.register(selector, ops, attachment);
/*     */       }
/*     */     } catch (ClosedChannelException e) {
/* 507 */       log.error("Register channel error", e);
/* 508 */       this.controller.notifyException(e);
/*     */     } finally {
/* 510 */       this.gate.unlock();
/*     */     }
/*     */   }
/*     */   
/*     */   final void wakeup() {
/* 515 */     if (this.wakenUp.compareAndSet(false, true)) {
/* 516 */       Selector selector = this.selector;
/* 517 */       if (selector != null) {
/* 518 */         selector.wakeup();
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   final void selectNow() throws IOException {
/* 524 */     Selector selector = this.selector;
/* 525 */     if (selector != null) {
/* 526 */       selector.selectNow();
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\google\code\yanf4j\nio\impl\Reactor.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */