/*     */ package com.google.code.yanf4j.util;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.PrintStream;
/*     */ import java.lang.reflect.Method;
/*     */ import java.net.InetAddress;
/*     */ import java.net.InetSocketAddress;
/*     */ import java.nio.channels.Selector;
/*     */ import java.nio.channels.spi.SelectorProvider;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class SystemUtils
/*     */ {
/*  44 */   public static final String OS_NAME = System.getProperty("os.name");
/*     */   
/*  46 */   private static boolean isLinuxPlatform = false;
/*     */   public static final String JAVA_VERSION;
/*     */   
/*  49 */   static { if ((OS_NAME != null) && (OS_NAME.toLowerCase().indexOf("linux") >= 0)) {
/*  50 */       isLinuxPlatform = true;
/*     */     }
/*     */     
/*  53 */     JAVA_VERSION = System.getProperty("java.version");
/*     */     
/*  55 */     isAfterJava6u4Version = false;
/*     */     
/*  57 */     if (JAVA_VERSION != null)
/*     */     {
/*  59 */       if ((JAVA_VERSION.indexOf("1.4.") >= 0) || (JAVA_VERSION.indexOf("1.5.") >= 0))
/*     */       {
/*  61 */         isAfterJava6u4Version = false;
/*  62 */       } else if (JAVA_VERSION.indexOf("1.6.") >= 0) {
/*  63 */         int index = JAVA_VERSION.indexOf("_");
/*  64 */         if (index > 0) {
/*  65 */           String subVersionStr = JAVA_VERSION.substring(index + 1);
/*  66 */           if ((subVersionStr != null) && (subVersionStr.length() > 0)) {
/*     */             try {
/*  68 */               int subVersion = Integer.parseInt(subVersionStr);
/*  69 */               if (subVersion >= 4) {
/*  70 */                 isAfterJava6u4Version = true;
/*     */               }
/*     */             }
/*     */             catch (NumberFormatException e) {}
/*     */           }
/*     */         }
/*     */       }
/*     */       else
/*     */       {
/*  79 */         isAfterJava6u4Version = true;
/*     */       } }
/*     */   }
/*     */   
/*     */   private static boolean isAfterJava6u4Version;
/*     */   public static final boolean isLinuxPlatform() {
/*  85 */     return isLinuxPlatform;
/*     */   }
/*     */   
/*     */   public static final boolean isAfterJava6u4Version() {
/*  89 */     return isAfterJava6u4Version;
/*     */   }
/*     */   
/*     */   public static void main(String[] args) {
/*  93 */     System.out.println(isAfterJava6u4Version());
/*     */   }
/*     */   
/*     */   public static final int getSystemThreadCount() {
/*  97 */     return getCpuProcessorCount();
/*     */   }
/*     */   
/*     */   public static final int getCpuProcessorCount() {
/* 101 */     return Runtime.getRuntime().availableProcessors();
/*     */   }
/*     */   
/*     */   public static final Selector openSelector() throws IOException {
/* 105 */     Selector result = null;
/*     */     
/* 107 */     if (isLinuxPlatform()) {
/*     */       try {
/* 109 */         Class<?> providerClazz = Class.forName("sun.nio.ch.EPollSelectorProvider");
/*     */         
/* 111 */         if (providerClazz != null) {
/*     */           try {
/* 113 */             Method method = providerClazz.getMethod("provider", new Class[0]);
/* 114 */             if (method != null) {
/* 115 */               SelectorProvider selectorProvider = (SelectorProvider)method.invoke(null, new Object[0]);
/*     */               
/* 117 */               if (selectorProvider != null) {
/* 118 */                 result = selectorProvider.openSelector();
/*     */               }
/*     */             }
/*     */           }
/*     */           catch (Exception e) {}
/*     */         }
/*     */       }
/*     */       catch (Exception e) {}
/*     */     }
/*     */     
/*     */ 
/* 129 */     if (result == null) {
/* 130 */       result = Selector.open();
/*     */     }
/* 132 */     return result;
/*     */   }
/*     */   
/*     */   public static final String getRawAddress(InetSocketAddress inetSocketAddress)
/*     */   {
/* 137 */     InetAddress address = inetSocketAddress.getAddress();
/* 138 */     return address != null ? address.getHostAddress() : inetSocketAddress.getHostName();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\google\code\yanf4j\util\SystemUtils.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */