/*     */ package com.netapp.asup.data.function.sort;
/*     */ 
/*     */ import com.netapp.asup.common.AsupLogger;
/*     */ import java.util.Comparator;
/*     */ 
/*     */ 
/*     */ 
/*     */ public class Comparators
/*     */ {
/*  10 */   private static final AsupLogger LOGGER = AsupLogger.getLogger(Comparators.class);
/*     */   
/*     */   static class Typecomparator<T extends Comparable<T>>
/*     */     implements Comparator<T>
/*     */   {
/*     */     private SortType sortType;
/*     */     
/*     */     public Typecomparator(SortType sortType)
/*     */     {
/*  19 */       this.sortType = sortType;
/*     */     }
/*     */     
/*     */ 
/*     */     public int compare(T o1, T o2)
/*     */     {
/*  25 */       switch (Comparators.1.$SwitchMap$com$netapp$asup$data$function$sort$SortType[this.sortType.ordinal()]) {
/*     */       case 1: 
/*  27 */         if ((null == o1) && (null == o2))
/*  28 */           return 0;
/*  29 */         if (null == o1)
/*  30 */           return -1;
/*  31 */         if (null == o2) {
/*  32 */           return 1;
/*     */         }
/*  34 */         return o1.compareTo(o2);
/*     */       
/*     */       case 2: 
/*  37 */         if ((null == o1) && (null == o2))
/*  38 */           return 0;
/*  39 */         if (null == o2)
/*  40 */           return -1;
/*  41 */         if (null == o1) {
/*  42 */           return 1;
/*     */         }
/*  44 */         return o2.compareTo(o1);
/*     */       }
/*     */       
/*  47 */       return 0;
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public static int compare(String attrName, String allAttribute1, String allAttribute2, Class<?> attrType, SortType sortType)
/*     */   {
/*     */     try
/*     */     {
/*  58 */       if (attrType.equals(Integer.class)) {
/*  59 */         Typecomparator<Integer> typecomparator = new Typecomparator(sortType);
/*     */         
/*  61 */         return typecomparator.compare(getIntegerValue(allAttribute1), getIntegerValue(allAttribute2));
/*     */       }
/*  63 */       if (attrType.equals(Double.class)) {
/*  64 */         Typecomparator<Double> typecomparator = new Typecomparator(sortType);
/*     */         
/*  66 */         return typecomparator.compare(getDoubleValue(allAttribute1), getDoubleValue(allAttribute2));
/*     */       }
/*     */     }
/*     */     catch (NumberFormatException e) {
/*  70 */       LOGGER.warn("-9999", "Using default string type comparison for attribute:" + attrName + ", Since failure in comparison using type:" + attrType);
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  77 */     if (attrType.equals(Boolean.class)) {
/*  78 */       Typecomparator<Boolean> typecomparator = new Typecomparator(sortType);
/*     */       
/*  80 */       return typecomparator.compare(getBooleanValue(allAttribute1), getBooleanValue(allAttribute2));
/*     */     }
/*     */     
/*     */ 
/*  84 */     Typecomparator<String> typecomparator = new Typecomparator(sortType);
/*     */     
/*  86 */     return typecomparator.compare(allAttribute1, allAttribute2);
/*     */   }
/*     */   
/*     */   private static Integer getIntegerValue(String allAttribute1)
/*     */   {
/*  91 */     Integer attrValueLeft = null;
/*  92 */     if (null != allAttribute1) {
/*  93 */       attrValueLeft = Integer.valueOf(allAttribute1);
/*     */     }
/*  95 */     return attrValueLeft;
/*     */   }
/*     */   
/*     */   private static Double getDoubleValue(String allAttribute) {
/*  99 */     Double attrValueLeft = null;
/* 100 */     if (null != allAttribute) {
/* 101 */       attrValueLeft = Double.valueOf(allAttribute);
/*     */     }
/* 103 */     return attrValueLeft;
/*     */   }
/*     */   
/*     */   private static Boolean getBooleanValue(String allAttribute) {
/* 107 */     Boolean attrValue = null;
/* 108 */     if (null != allAttribute) {
/* 109 */       attrValue = Boolean.valueOf(allAttribute);
/*     */     }
/* 111 */     return attrValue;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\function\sort\Comparators.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */