/*     */ package com.netapp.asup.data.objects;
/*     */ 
/*     */ import com.netapp.asup.data.exception.ARMARemoteCallException;
/*     */ import java.io.InputStream;
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import org.apache.avro.generic.GenericRecord;
/*     */ 
/*     */ public class Response extends AvroTransmissionObject
/*     */ {
/*     */   private static final String FILTERS_APPLIED = "filtersApplied";
/*     */   private static final String ID = "id";
/*     */   
/*     */   public static enum ResponseField implements AvroField
/*     */   {
/*  17 */     OBJECTS("objects", Objects.class, Map.class), 
/*  18 */     OPTIONS("options", Options.class, Map.class), 
/*  19 */     LOGEVENTS("logEvents", LogEvents.class, GenericRecord.class), 
/*  20 */     PERFCOUNTERS("perfCounters", PerfCounters.class, GenericRecord.class), 
/*  21 */     FUNCTIONS("functions", Functions.class, GenericRecord.class), 
/*  22 */     STATUS_HEADER("statusHeader", StatusHeader.class, GenericRecord.class);
/*     */     
/*     */     private final String tagName;
/*     */     private final Class<? extends AvroObject<?>> type;
/*     */     private final Class<?> objectType;
/*     */     private static List<ResponseField> nonMergefields;
/*     */     
/*     */     private ResponseField(String tagName, Class<? extends AvroObject<?>> type, Class<?> objectType) {
/*  30 */       this.tagName = tagName;
/*  31 */       this.type = type;
/*  32 */       this.objectType = objectType;
/*     */     }
/*     */     
/*     */     public String getTagName() {
/*  36 */       return this.tagName;
/*     */     }
/*     */     
/*     */     public <T> T getFieldType()
/*     */     {
/*  41 */       return this;
/*     */     }
/*     */     
/*     */     public Class<? extends AvroObject<?>> getType() {
/*  45 */       return this.type;
/*     */     }
/*     */     
/*     */     public Class<?> getObjectType() {
/*  49 */       return this.objectType;
/*     */     }
/*     */     
/*     */ 
/*     */     public static List<ResponseField> getNonMergefields()
/*     */     {
/*  55 */       return nonMergefields;
/*     */     }
/*     */     
/*     */     static
/*     */     {
/*  52 */       nonMergefields = new ArrayList();
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  60 */       nonMergefields.add(LOGEVENTS);
/*  61 */       nonMergefields.add(PERFCOUNTERS);
/*  62 */       nonMergefields.add(STATUS_HEADER);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   public Objects getObjects()
/*     */   {
/*  69 */     return (Objects)getField(ResponseField.OBJECTS);
/*     */   }
/*     */   
/*     */   public Options getOptions() {
/*  73 */     return (Options)getField(ResponseField.OPTIONS);
/*     */   }
/*     */   
/*     */   public Functions getFunctions() {
/*  77 */     return (Functions)getField(ResponseField.FUNCTIONS);
/*     */   }
/*     */   
/*     */   public void setFiltersApplied(String identifierProcessed) {
/*  81 */     putStringValue("filtersApplied", identifierProcessed);
/*     */   }
/*     */   
/*     */   public String isFiltersApplied() {
/*  85 */     return getStringValue("filtersApplied");
/*     */   }
/*     */   
/*     */   public PerfCounters getPerfCounters() {
/*  89 */     return (PerfCounters)getField(ResponseField.PERFCOUNTERS);
/*     */   }
/*     */   
/*     */   public StatusHeader getStatusHeader() {
/*  93 */     return (StatusHeader)getField(ResponseField.STATUS_HEADER);
/*     */   }
/*     */   
/*     */   public LogEvents getLogEvents()
/*     */   {
/*  98 */     return (LogEvents)getField(ResponseField.LOGEVENTS);
/*     */   }
/*     */   
/*     */ 
/*     */   public Response(String requestId)
/*     */   {
/* 104 */     super(ARMASchema.RESPONSE, java.util.Arrays.asList(ResponseField.values()), requestId);
/*     */     
/* 106 */     setId(requestId);
/*     */   }
/*     */   
/*     */   public static Response initialize(String requestId) {
/* 110 */     Response response = new Response(requestId);
/*     */     
/* 112 */     response.getFunctions();
/* 113 */     response.getPerfCounters();
/* 114 */     response.getLogEvents();
/* 115 */     response.getStatusHeader();
/* 116 */     response.setFiltersApplied(String.valueOf(Boolean.FALSE));
/* 117 */     return response;
/*     */   }
/*     */   
/*     */   public static Response defaultInitialize(String requestId) {
/* 121 */     Response response = new Response(requestId);
/*     */     
/* 123 */     response.getFunctions();
/* 124 */     response.getPerfCounters();
/* 125 */     response.getLogEvents();
/* 126 */     response.getOptions();
/* 127 */     response.getStatusHeader();
/* 128 */     response.setFiltersApplied(String.valueOf(Boolean.FALSE));
/* 129 */     return response;
/*     */   }
/*     */   
/*     */   public void setId(String id) {
/* 133 */     putStringValue("id", id);
/*     */   }
/*     */   
/*     */   public void read(InputStream is) throws ARMARemoteCallException {
/* 137 */     super.read(is);
/*     */   }
/*     */   
/*     */   public void read(byte[] bytes) throws ARMARemoteCallException {
/* 141 */     super.read(bytes);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\objects\Response.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */