/*     */ package net.rubyeye.xmemcached.impl;
/*     */ 
/*     */ import com.google.code.yanf4j.core.WriteMessage;
/*     */ import com.google.code.yanf4j.util.LinkedTransferQueue;
/*     */ import java.util.Collection;
/*     */ import java.util.Iterator;
/*     */ import java.util.concurrent.TimeUnit;
/*     */ import net.rubyeye.xmemcached.FlowControl;
/*     */ import net.rubyeye.xmemcached.command.Command;
/*     */ 
/*     */ 
/*     */ public class FlowControlLinkedTransferQueue
/*     */   extends LinkedTransferQueue<WriteMessage>
/*     */ {
/*     */   private FlowControl flowControl;
/*     */   
/*     */   public FlowControlLinkedTransferQueue(FlowControl flowControl)
/*     */   {
/*  19 */     this.flowControl = flowControl;
/*     */   }
/*     */   
/*     */   private void checkPermits(WriteMessage e) {
/*  23 */     if ((e.getMessage() instanceof Command)) {
/*  24 */       Command cmd = (Command)e.getMessage();
/*  25 */       if (cmd.isNoreply()) {
/*  26 */         int i = 3;
/*  27 */         boolean success = false;
/*  28 */         while (i-- > 0) {
/*  29 */           if (this.flowControl.aquire()) {
/*  30 */             success = true;
/*  31 */             break;
/*     */           }
/*     */           
/*  34 */           Thread.yield();
/*     */         }
/*     */         
/*  37 */         if (!success) {
/*  38 */           throw new IllegalStateException("No permit for noreply operation,max=" + this.flowControl.max());
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public void put(WriteMessage e)
/*     */     throws InterruptedException
/*     */   {
/*  47 */     checkPermits(e);
/*  48 */     super.put(e);
/*     */   }
/*     */   
/*     */   public boolean offer(WriteMessage e, long timeout, TimeUnit unit)
/*     */     throws InterruptedException
/*     */   {
/*  54 */     checkPermits(e);
/*  55 */     return super.offer(e, timeout, unit);
/*     */   }
/*     */   
/*     */   public boolean offer(WriteMessage e)
/*     */   {
/*  60 */     checkPermits(e);
/*  61 */     return super.offer(e);
/*     */   }
/*     */   
/*     */   public void transfer(WriteMessage e) throws InterruptedException
/*     */   {
/*  66 */     checkPermits(e);
/*  67 */     super.transfer(e);
/*     */   }
/*     */   
/*     */   public boolean tryTransfer(WriteMessage e, long timeout, TimeUnit unit)
/*     */     throws InterruptedException
/*     */   {
/*  73 */     checkPermits(e);
/*  74 */     return super.tryTransfer(e, timeout, unit);
/*     */   }
/*     */   
/*     */   public boolean tryTransfer(WriteMessage e)
/*     */   {
/*  79 */     checkPermits(e);
/*  80 */     return super.tryTransfer(e);
/*     */   }
/*     */   
/*     */   public WriteMessage take() throws InterruptedException
/*     */   {
/*  85 */     WriteMessage rt = (WriteMessage)super.take();
/*  86 */     releasePermit(rt);
/*  87 */     return rt;
/*     */   }
/*     */   
/*     */   public WriteMessage poll(long timeout, TimeUnit unit)
/*     */     throws InterruptedException
/*     */   {
/*  93 */     WriteMessage rt = (WriteMessage)super.poll(timeout, unit);
/*  94 */     releasePermit(rt);
/*  95 */     return rt;
/*     */   }
/*     */   
/*     */   public WriteMessage poll()
/*     */   {
/* 100 */     WriteMessage rt = (WriteMessage)super.poll();
/* 101 */     releasePermit(rt);
/* 102 */     return rt;
/*     */   }
/*     */   
/*     */   private void releasePermit(WriteMessage rt) {
/* 106 */     if ((rt != null) && 
/* 107 */       ((rt.getMessage() instanceof Command))) {
/* 108 */       Command cmd = (Command)rt.getMessage();
/* 109 */       if (cmd.isNoreply()) {
/* 110 */         this.flowControl.release();
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public int drainTo(Collection<? super WriteMessage> c)
/*     */   {
/* 119 */     return super.drainTo(c);
/*     */   }
/*     */   
/*     */   public int drainTo(Collection<? super WriteMessage> c, int maxElements)
/*     */   {
/* 124 */     return super.drainTo(c, maxElements);
/*     */   }
/*     */   
/*     */   public Iterator<WriteMessage> iterator()
/*     */   {
/* 129 */     return super.iterator();
/*     */   }
/*     */   
/*     */   public WriteMessage peek()
/*     */   {
/* 134 */     return (WriteMessage)super.peek();
/*     */   }
/*     */   
/*     */   public boolean isEmpty()
/*     */   {
/* 139 */     return super.isEmpty();
/*     */   }
/*     */   
/*     */   public boolean hasWaitingConsumer()
/*     */   {
/* 144 */     return super.hasWaitingConsumer();
/*     */   }
/*     */   
/*     */   public int size()
/*     */   {
/* 149 */     return super.size();
/*     */   }
/*     */   
/*     */   public int getWaitingConsumerCount()
/*     */   {
/* 154 */     return super.getWaitingConsumerCount();
/*     */   }
/*     */   
/*     */   public int remainingCapacity()
/*     */   {
/* 159 */     return super.remainingCapacity();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\impl\FlowControlLinkedTransferQueue.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */