/*     */ package net.sf.sevenzipjbinding;
/*     */ 
/*     */ import java.io.File;
/*     */ import java.io.FileOutputStream;
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.security.AccessController;
/*     */ import java.security.PrivilegedAction;
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ import java.util.Properties;
/*     */ import java.util.Random;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SevenZip
/*     */ {
/*     */   private static final String SYSTEM_PROPERTY_TMP = "java.io.tmpdir";
/*     */   private static final String SYSTEM_PROPERTY_SEVEN_ZIP_NO_DO_PRIVILEGED_INITIALIZATION = "sevenzip.no_doprivileged_initialization";
/*     */   private static final String PROPERTY_SEVENZIPJBINDING_LIBNAME = "sevenzipjbinding.libname.%s";
/*     */   private static final String PROPERTY_BUILD_REF = "build.ref";
/*     */   private static final String SEVENZIPJBINDING_LIB_PROPERTIES_FILENAME = "sevenzipjbinding-lib.properties";
/*     */   private static final String SEVENZIPJBINDING_PLATFORMS_PROPRETIES_FILENAME = "/sevenzipjbinding-platforms.properties";
/* 132 */   private static boolean autoInitializationWillOccur = true;
/* 133 */   private static boolean initializationSuccessful = false;
/* 134 */   private static SevenZipNativeInitializationException lastInitializationException = null;
/* 135 */   private static List<String> availablePlatforms = null;
/* 136 */   private static String usedPlatform = null;
/* 137 */   private static File[] temporaryArtifacts = null;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static boolean isInitializedSuccessfully()
/*     */   {
/* 156 */     return initializationSuccessful;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static Throwable getLastInitializationException()
/*     */   {
/* 166 */     return lastInitializationException;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static boolean isAutoInitializationWillOccur()
/*     */   {
/* 181 */     return autoInitializationWillOccur;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static String getUsedPlatform()
/*     */   {
/* 192 */     return usedPlatform;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static List<String> getPlatformList()
/*     */     throws SevenZipNativeInitializationException
/*     */   {
/* 204 */     if (availablePlatforms != null) {
/* 205 */       return availablePlatforms;
/*     */     }
/*     */     
/* 208 */     InputStream localInputStream = SevenZip.class.getResourceAsStream("/sevenzipjbinding-platforms.properties");
/*     */     
/* 210 */     if (localInputStream == null) {
/* 211 */       throw new SevenZipNativeInitializationException("Can not find 7-Zip-JBinding platform property file /sevenzipjbinding-platforms.properties. Make sure the 'sevenzipjbinding-<Platform>.jar' file is in the class path or consider initializing SevenZipJBinding manualy using one of the offered initialization methods: 'net.sf.sevenzipjbinding.SevenZip.init*()'");
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 218 */     Properties localProperties = new Properties();
/*     */     try {
/* 220 */       localProperties.load(localInputStream);
/*     */     } catch (IOException localIOException) {
/* 222 */       throwInitException(localIOException, "Error loading existing property file /sevenzipjbinding-platforms.properties");
/*     */     }
/*     */     
/*     */ 
/* 226 */     ArrayList localArrayList = new ArrayList();
/* 227 */     for (int i = 1;; i++) {
/* 228 */       String str = localProperties.getProperty("platform." + i);
/* 229 */       if (str == null) {
/*     */         break;
/*     */       }
/* 232 */       localArrayList.add(str);
/*     */     }
/*     */     
/* 235 */     return availablePlatforms = localArrayList;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static File[] getTemporaryArtifacts()
/*     */   {
/* 245 */     return temporaryArtifacts;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static void initSevenZipFromPlatformJAR()
/*     */     throws SevenZipNativeInitializationException
/*     */   {
/* 267 */     initSevenZipFromPlatformJARIntern(null, null);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static void initSevenZipFromPlatformJAR(File paramFile)
/*     */     throws SevenZipNativeInitializationException
/*     */   {
/* 293 */     initSevenZipFromPlatformJARIntern(null, paramFile);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static void initSevenZipFromPlatformJAR(String paramString, File paramFile)
/*     */     throws SevenZipNativeInitializationException
/*     */   {
/* 325 */     initSevenZipFromPlatformJARIntern(paramString, paramFile);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static void initSevenZipFromPlatformJAR(String paramString)
/*     */     throws SevenZipNativeInitializationException
/*     */   {
/* 352 */     initSevenZipFromPlatformJARIntern(paramString, null);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private static void initSevenZipFromPlatformJARIntern(String paramString, File paramFile)
/*     */     throws SevenZipNativeInitializationException
/*     */   {
/*     */     try
/*     */     {
/* 372 */       autoInitializationWillOccur = false;
/* 373 */       if (initializationSuccessful)
/*     */       {
/* 375 */         return;
/*     */       }
/*     */       
/* 378 */       determineAndSetUsedPlatform(paramString);
/* 379 */       Properties localProperties = loadSevenZipJBindingLibProperties();
/* 380 */       File localFile1 = createOrVerifyTmpDir(paramFile);
/* 381 */       File localFile2 = getOrCreateSevenZipJBindingTmpDir(localFile1, localProperties);
/* 382 */       List localList = copyOrSkipLibraries(localProperties, localFile2);
/* 383 */       loadNativeLibraries(localList);
/* 384 */       nativeInitialization();
/*     */     } catch (SevenZipNativeInitializationException localSevenZipNativeInitializationException) {
/* 386 */       lastInitializationException = localSevenZipNativeInitializationException;
/* 387 */       throw localSevenZipNativeInitializationException;
/*     */     }
/*     */   }
/*     */   
/*     */   private static void determineAndSetUsedPlatform(String paramString) throws SevenZipNativeInitializationException {
/* 392 */     if (paramString == null) {
/* 393 */       usedPlatform = getPlatformBestMatch();
/*     */     } else {
/* 395 */       usedPlatform = paramString;
/*     */     }
/*     */   }
/*     */   
/*     */   private static Properties loadSevenZipJBindingLibProperties() throws SevenZipNativeInitializationException {
/* 400 */     String str = "/" + usedPlatform + "/";
/*     */     
/*     */ 
/* 403 */     InputStream localInputStream = SevenZip.class.getResourceAsStream(str + "sevenzipjbinding-lib.properties");
/*     */     
/* 405 */     if (localInputStream == null) {
/* 406 */       throwInitException("error loading property file '" + str + "sevenzipjbinding-lib.properties" + "' from a jar-file 'sevenzipjbinding-<Platform>.jar'. Is the platform jar-file not in the class path?");
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 412 */     Properties localProperties = new Properties();
/*     */     try {
/* 414 */       localProperties.load(localInputStream);
/*     */     } catch (IOException localIOException) {
/* 416 */       throwInitException("error loading property file 'sevenzipjbinding-lib.properties' from a jar-file 'sevenzipjbinding-<Platform>.jar'");
/*     */     }
/*     */     
/* 419 */     return localProperties;
/*     */   }
/*     */   
/*     */   private static File createOrVerifyTmpDir(File paramFile) throws SevenZipNativeInitializationException {
/*     */     File localFile;
/* 424 */     if (paramFile != null) {
/* 425 */       localFile = paramFile;
/*     */     } else {
/* 427 */       String str = System.getProperty("java.io.tmpdir");
/* 428 */       if (str == null) {
/* 429 */         throwInitException("can't determinte tmp directory. Use may use -Djava.io.tmpdir=<path to tmp dir> parameter for jvm to fix this.");
/*     */       }
/*     */       
/* 432 */       localFile = new File(str);
/*     */     }
/*     */     
/* 435 */     if ((!localFile.exists()) || (!localFile.isDirectory())) {
/* 436 */       throwInitException("invalid tmp directory '" + paramFile + "'");
/*     */     }
/*     */     
/* 439 */     if (!localFile.canWrite()) {
/* 440 */       throwInitException("can't create files in '" + localFile.getAbsolutePath() + "'");
/*     */     }
/* 442 */     return localFile;
/*     */   }
/*     */   
/*     */   private static File getOrCreateSevenZipJBindingTmpDir(File paramFile, Properties paramProperties) throws SevenZipNativeInitializationException
/*     */   {
/* 447 */     String str = getOrGenerateBuildRef(paramProperties);
/* 448 */     File localFile = new File(paramFile.getAbsolutePath() + File.separator + "SevenZipJBinding-" + str);
/* 449 */     if ((!localFile.exists()) && 
/* 450 */       (!localFile.mkdir())) {
/* 451 */       throwInitException("Directory '" + paramFile.getAbsolutePath() + "' couldn't be created");
/*     */     }
/*     */     
/* 454 */     return localFile;
/*     */   }
/*     */   
/*     */   private static String getOrGenerateBuildRef(Properties paramProperties) {
/* 458 */     String str = paramProperties.getProperty("build.ref");
/* 459 */     if (str == null) {
/* 460 */       str = Integer.toString(new Random().nextInt(10000000));
/*     */     }
/* 462 */     return str;
/*     */   }
/*     */   
/*     */   private static List<File> copyOrSkipLibraries(Properties paramProperties, File paramFile) throws SevenZipNativeInitializationException
/*     */   {
/* 467 */     ArrayList localArrayList = new ArrayList(5);
/* 468 */     for (int i = 1;; i++) {
/* 469 */       String str1 = String.format("sevenzipjbinding.libname.%s", new Object[] { Integer.valueOf(i) });
/* 470 */       String str2 = paramProperties.getProperty(str1);
/* 471 */       if (str2 == null) {
/* 472 */         if (localArrayList.size() != 0) break;
/* 473 */         throwInitException("property file 'sevenzipjbinding-lib.properties' from a jar-file 'sevenzipjbinding-<Platform>.jar' don't contain the property named '" + str1 + "'");
/*     */       }
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 481 */       File localFile = new File(paramFile.getAbsolutePath() + File.separatorChar + str2);
/*     */       
/* 483 */       if (!localFile.exists()) {
/* 484 */         InputStream localInputStream = SevenZip.class.getResourceAsStream("/" + usedPlatform + "/" + str2);
/* 485 */         if (localInputStream == null) {
/* 486 */           throwInitException("error loading native library '" + str2 + "' from a jar-file 'sevenzipjbinding-<Platform>.jar'.");
/*     */         }
/*     */         
/*     */ 
/* 490 */         copyLibraryToFS(localFile, localInputStream);
/*     */       }
/* 492 */       localArrayList.add(localFile);
/*     */     }
/* 494 */     applyTemporaryArtifacts(paramFile, localArrayList);
/* 495 */     return localArrayList;
/*     */   }
/*     */   
/*     */   private static void applyTemporaryArtifacts(File paramFile, List<File> paramList) {
/* 499 */     temporaryArtifacts = new File[paramList.size() + 1];
/* 500 */     paramList.toArray(temporaryArtifacts);
/* 501 */     temporaryArtifacts[(temporaryArtifacts.length - 1)] = paramFile;
/*     */   }
/*     */   
/*     */   private static void loadNativeLibraries(List<File> paramList) throws SevenZipNativeInitializationException
/*     */   {
/* 506 */     for (int i = paramList.size() - 1; i != -1; i--) {
/* 507 */       String str = ((File)paramList.get(i)).getAbsolutePath();
/*     */       try {
/* 509 */         System.load(str);
/*     */       } catch (Throwable localThrowable) {
/* 511 */         throw new SevenZipNativeInitializationException("7-Zip-JBinding initialization failed: Error loading native library: '" + str + "'", localThrowable);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static void initLoadedLibraries()
/*     */     throws SevenZipNativeInitializationException
/*     */   {
/* 527 */     if (initializationSuccessful) {
/* 528 */       return;
/*     */     }
/* 530 */     autoInitializationWillOccur = false;
/* 531 */     nativeInitialization();
/*     */   }
/*     */   
/*     */   private static void nativeInitialization() throws SevenZipNativeInitializationException {
/* 535 */     String str1 = System.getProperty("sevenzip.no_doprivileged_initialization");
/* 536 */     String[] arrayOfString = new String[1];
/* 537 */     final Throwable[] arrayOfThrowable = new Throwable[1];
/* 538 */     if ((str1 == null) || (str1.trim().equals("0"))) {
/* 539 */       AccessController.doPrivileged(new PrivilegedAction() {
/*     */         public Void run() {
/*     */           try {
/* 542 */             this.val$errorMessage[0] = SevenZip.access$000();
/*     */           }
/*     */           catch (Throwable localThrowable) {
/* 545 */             arrayOfThrowable[0] = localThrowable;
/*     */           }
/* 547 */           return null;
/*     */         }
/*     */       });
/*     */     } else {
/* 551 */       arrayOfString[0] = nativeInitSevenZipLibrary();
/*     */     }
/* 553 */     if ((arrayOfString[0] != null) || (arrayOfThrowable[0] != null)) {
/* 554 */       String str2 = arrayOfString[0];
/* 555 */       if (str2 == null) {
/* 556 */         str2 = "No message";
/*     */       }
/* 558 */       lastInitializationException = new SevenZipNativeInitializationException("Error initializing 7-Zip-JBinding: " + str2, arrayOfThrowable[0]);
/*     */       
/* 560 */       throw lastInitializationException;
/*     */     }
/* 562 */     initializationSuccessful = true;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static ISevenZipInArchive openInArchive(ArchiveFormat paramArchiveFormat, IInStream paramIInStream, IArchiveOpenCallback paramIArchiveOpenCallback)
/*     */     throws SevenZipException
/*     */   {
/*     */     
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 590 */     if (paramArchiveFormat != null) {
/* 591 */       return callNativeOpenArchive(paramArchiveFormat.getMethodName(), paramIInStream, paramIArchiveOpenCallback);
/*     */     }
/* 593 */     return callNativeOpenArchive(null, paramIInStream, paramIArchiveOpenCallback);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static ISevenZipInArchive openInArchive(ArchiveFormat paramArchiveFormat, IInStream paramIInStream, String paramString)
/*     */     throws SevenZipException
/*     */   {
/*     */     
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 621 */     if (paramArchiveFormat != null) {
/* 622 */       return callNativeOpenArchive(paramArchiveFormat.getMethodName(), paramIInStream, new ArchiveOpenCryptoCallback(paramString));
/*     */     }
/*     */     
/* 625 */     return callNativeOpenArchive(null, paramIInStream, new ArchiveOpenCryptoCallback(paramString));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static ISevenZipInArchive openInArchive(ArchiveFormat paramArchiveFormat, IInStream paramIInStream)
/*     */     throws SevenZipException
/*     */   {
/*     */     
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 649 */     if (paramArchiveFormat != null) {
/* 650 */       return callNativeOpenArchive(paramArchiveFormat.getMethodName(), paramIInStream, new DummyOpenArchiveCallback(null));
/*     */     }
/* 652 */     return callNativeOpenArchive(null, paramIInStream, new DummyOpenArchiveCallback(null));
/*     */   }
/*     */   
/*     */   private static void ensureLibraryIsInitialized() {
/* 656 */     if (autoInitializationWillOccur) {
/* 657 */       autoInitializationWillOccur = false;
/*     */       try {
/* 659 */         initSevenZipFromPlatformJAR();
/*     */       } catch (SevenZipNativeInitializationException localSevenZipNativeInitializationException) {
/* 661 */         lastInitializationException = localSevenZipNativeInitializationException;
/* 662 */         throw new RuntimeException("SevenZipJBinding couldn't be initialized automaticly using initialization from platform depended JAR and the default temporary directory. Please, make sure the correct 'sevenzipjbinding-<Platform>.jar' file is in the class path or consider initializing SevenZipJBinding manualy using one of the offered initialization methods: 'net.sf.sevenzipjbinding.SevenZip.init*()'", localSevenZipNativeInitializationException);
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 669 */     if (!initializationSuccessful) {
/* 670 */       throw new RuntimeException("SevenZipJBinding wasn't initialized successfully last time.", lastInitializationException);
/*     */     }
/*     */   }
/*     */   
/*     */   private static void throwInitException(String paramString) throws SevenZipNativeInitializationException
/*     */   {
/* 676 */     throwInitException(null, paramString);
/*     */   }
/*     */   
/*     */   private static void throwInitException(Exception paramException, String paramString) throws SevenZipNativeInitializationException
/*     */   {
/* 681 */     throw new SevenZipNativeInitializationException("Error loading SevenZipJBinding native library into JVM: " + paramString + " [You may also try different SevenZipJBinding initialization methods " + "'net.sf.sevenzipjbinding.SevenZip.init*()' in order to solve this problem] ", paramException);
/*     */   }
/*     */   
/*     */ 
/*     */   private static void copyLibraryToFS(File paramFile, InputStream paramInputStream)
/*     */   {
/* 687 */     FileOutputStream localFileOutputStream = null;
/*     */     try {
/* 689 */       localFileOutputStream = new FileOutputStream(paramFile);
/* 690 */       byte[] arrayOfByte = new byte[65536];
/*     */       for (;;) {
/* 692 */         int i = paramInputStream.read(arrayOfByte);
/* 693 */         if (i <= 0) break;
/* 694 */         localFileOutputStream.write(arrayOfByte, 0, i);
/*     */       }
/*     */       return;
/*     */     }
/*     */     catch (Exception localException)
/*     */     {
/* 700 */       localException.printStackTrace();
/* 701 */       throw new RuntimeException("Error initializing SevenZipJBinding native library: can't copy native library out of a resource file to the temporary location: '" + paramFile.getAbsolutePath() + "'", localException);
/*     */     }
/*     */     finally
/*     */     {
/*     */       try {
/* 706 */         paramInputStream.close();
/*     */       }
/*     */       catch (IOException localIOException3) {}
/*     */       try
/*     */       {
/* 711 */         if (paramInputStream != null) {
/* 712 */           localFileOutputStream.close();
/*     */         }
/*     */       }
/*     */       catch (IOException localIOException4) {}
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private static String getPlatformBestMatch()
/*     */     throws SevenZipNativeInitializationException
/*     */   {
/* 730 */     List localList = getPlatformList();
/* 731 */     if (localList.size() == 1) {
/* 732 */       return (String)localList.get(0);
/*     */     }
/*     */     
/* 735 */     String str1 = System.getProperty("os.arch");
/* 736 */     String str2 = System.getProperty("os.name").split(" ")[0];
/* 737 */     if (localList.contains(str2 + "-" + str1)) {
/* 738 */       return str2 + "-" + str1;
/*     */     }
/*     */     
/*     */ 
/* 742 */     StringBuilder localStringBuilder = new StringBuilder("Can't find suited platform for os.arch=");
/* 743 */     localStringBuilder.append(str1);
/* 744 */     localStringBuilder.append(", os.name=");
/* 745 */     localStringBuilder.append(str2);
/* 746 */     localStringBuilder.append("... Available list of platforms: ");
/*     */     
/* 748 */     for (String str3 : localList) {
/* 749 */       localStringBuilder.append(str3);
/* 750 */       localStringBuilder.append(", ");
/*     */     }
/* 752 */     localStringBuilder.setLength(localStringBuilder.length() - 2);
/* 753 */     throwInitException(localStringBuilder.toString());
/* 754 */     return null;
/*     */   }
/*     */   
/*     */   private static ISevenZipInArchive callNativeOpenArchive(String paramString, IInStream paramIInStream, IArchiveOpenCallback paramIArchiveOpenCallback) throws SevenZipException
/*     */   {
/* 759 */     if (paramIInStream == null) {
/* 760 */       throw new NullPointerException("SevenZip.callNativeOpenArchive(...): inStream parameter is null");
/*     */     }
/* 762 */     return nativeOpenArchive(paramString, paramIInStream, paramIArchiveOpenCallback);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   private static native ISevenZipInArchive nativeOpenArchive(String paramString, IInStream paramIInStream, IArchiveOpenCallback paramIArchiveOpenCallback)
/*     */     throws SevenZipException;
/*     */   
/*     */ 
/*     */ 
/*     */   private static native String nativeInitSevenZipLibrary();
/*     */   
/*     */ 
/*     */ 
/*     */   private static class DummyOpenArchiveCallback
/*     */     implements IArchiveOpenCallback, ICryptoGetTextPassword
/*     */   {
/*     */     public void setCompleted(Long paramLong1, Long paramLong2) {}
/*     */     
/*     */ 
/*     */ 
/*     */     public void setTotal(Long paramLong1, Long paramLong2) {}
/*     */     
/*     */ 
/*     */ 
/*     */     public String cryptoGetTextPassword()
/*     */       throws SevenZipException
/*     */     {
/* 790 */       throw new SevenZipException("No password was provided for opening protected archive.");
/*     */     }
/*     */   }
/*     */   
/*     */   private static final class ArchiveOpenCryptoCallback implements IArchiveOpenCallback, ICryptoGetTextPassword {
/*     */     private final String passwordForOpen;
/*     */     
/*     */     public ArchiveOpenCryptoCallback(String paramString) {
/* 798 */       this.passwordForOpen = paramString;
/*     */     }
/*     */     
/*     */     public void setCompleted(Long paramLong1, Long paramLong2) {}
/*     */     
/*     */     public void setTotal(Long paramLong1, Long paramLong2) {}
/*     */     
/*     */     public String cryptoGetTextPassword()
/*     */       throws SevenZipException
/*     */     {
/* 808 */       return this.passwordForOpen;
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\sevenzipjbinding.jar!\net\sf\sevenzipjbinding\SevenZip.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */