/*     */ package org.codehaus.commons.compiler.samples;
/*     */ 
/*     */ import java.io.PrintStream;
/*     */ import org.codehaus.commons.compiler.CompilerFactoryFactory;
/*     */ import org.codehaus.commons.compiler.IClassBodyEvaluator;
/*     */ import org.codehaus.commons.compiler.ICompilerFactory;
/*     */ import org.codehaus.commons.compiler.ICookable;
/*     */ import org.codehaus.commons.compiler.IScriptEvaluator;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class ScriptDemo
/*     */   extends DemoBase
/*     */ {
/*     */   public static void main(String[] args)
/*     */     throws Exception
/*     */   {
/*  37 */     Class returnType = Void.TYPE;
/*  38 */     String[] parameterNames = new String[0];
/*  39 */     Class[] parameterTypes = new Class[0];
/*  40 */     Class[] thrownExceptions = new Class[0];
/*  41 */     String[] optionalDefaultImports = null;
/*     */     
/*     */ 
/*  44 */     for (int i = 0; i < args.length; i++) {
/*  45 */       String arg = args[i];
/*  46 */       if (!arg.startsWith("-")) break;
/*  47 */       if (arg.equals("-rt")) {
/*  48 */         returnType = DemoBase.stringToType(args[(++i)]);
/*     */       }
/*  50 */       else if (arg.equals("-pn")) {
/*  51 */         parameterNames = DemoBase.explode(args[(++i)]);
/*     */       }
/*  53 */       else if (arg.equals("-pt")) {
/*  54 */         parameterTypes = DemoBase.stringToTypes(args[(++i)]);
/*     */       }
/*  56 */       else if (arg.equals("-te")) {
/*  57 */         thrownExceptions = DemoBase.stringToTypes(args[(++i)]);
/*     */       }
/*  59 */       else if (arg.equals("-di")) {
/*  60 */         optionalDefaultImports = DemoBase.explode(args[(++i)]);
/*     */       }
/*  62 */       else if (arg.equals("-help")) {
/*  63 */         System.err.println("Usage:");
/*  64 */         System.err.println("  ScriptDemo { <option> } <script> { <parameter-value> }");
/*  65 */         System.err.println("Valid options are");
/*  66 */         System.err.println(" -rt <return-type>                            (default: void)");
/*  67 */         System.err.println(" -pn <comma-separated-parameter-names>        (default: none)");
/*  68 */         System.err.println(" -pt <comma-separated-parameter-types>        (default: none)");
/*  69 */         System.err.println(" -te <comma-separated-thrown-exception-types> (default: none)");
/*  70 */         System.err.println(" -di <comma-separated-default-imports>        (default: none)");
/*  71 */         System.err.println(" -help");
/*  72 */         System.err.println("The number of parameter names, types and values must be identical.");
/*  73 */         System.exit(0);
/*     */       }
/*     */       else {
/*  76 */         System.err.println("Invalid command line option \"" + arg + "\"; try \"-help\".");
/*  77 */         System.exit(1);
/*     */       }
/*     */     }
/*     */     
/*  81 */     if (i == args.length) {
/*  82 */       System.err.println("Script missing on command line; try \"-help\".");
/*  83 */       System.exit(1);
/*     */     }
/*  85 */     String script = args[(i++)];
/*     */     
/*  87 */     if (parameterTypes.length != parameterNames.length) {
/*  88 */       System.err.println("Parameter type count and parameter name count do not match; try \"-help\".");
/*  89 */       System.exit(1);
/*     */     }
/*     */     
/*     */ 
/*  93 */     if (args.length - i != parameterNames.length) {
/*  94 */       System.err.println("Argument and parameter count do not match; try \"-help\".");
/*  95 */       System.exit(1);
/*     */     }
/*     */     
/*     */ 
/*  99 */     Object[] arguments = new Object[parameterNames.length];
/* 100 */     for (int j = 0; j < parameterNames.length; j++) {
/* 101 */       arguments[j] = DemoBase.createObject(parameterTypes[j], args[(i + j)]);
/*     */     }
/*     */     
/*     */ 
/* 105 */     IScriptEvaluator se = CompilerFactoryFactory.getDefaultCompilerFactory().newScriptEvaluator();
/* 106 */     se.setReturnType(returnType);
/* 107 */     se.setDefaultImports(optionalDefaultImports);
/* 108 */     se.setParameters(parameterNames, parameterTypes);
/* 109 */     se.setThrownExceptions(thrownExceptions);
/* 110 */     se.cook(script);
/*     */     
/*     */ 
/* 113 */     Object res = se.evaluate(arguments);
/*     */     
/*     */ 
/* 116 */     System.out.println("Result = " + DemoBase.toString(res));
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\commons\compiler\samples\ScriptDemo.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */