/*     */ package org.codehaus.janino.util;
/*     */ 
/*     */ import java.io.FilterWriter;
/*     */ import java.io.IOException;
/*     */ import java.io.Writer;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Arrays;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class AutoIndentWriter
/*     */   extends FilterWriter
/*     */ {
/*     */   public static final char TABULATOR = '￿';
/*     */   public static final char CLEAR_TABULATORS = '￾';
/*     */   public static final char INDENT = '�';
/*     */   public static final char UNINDENT = '￼';
/*  42 */   StringBuffer lineBuffer = new StringBuffer();
/*  43 */   int indentation = 0;
/*  44 */   List tabulatorBuffer = null;
/*     */   int tabulatorIndentation;
/*     */   
/*     */   public AutoIndentWriter(Writer out) {
/*  48 */     super(out);
/*     */   }
/*     */   
/*     */   public void write(char[] cbuf, int off, int len) throws IOException {
/*  52 */     for (; len > 0; len--) write(cbuf[(off++)]);
/*     */   }
/*     */   
/*     */   public void write(String str, int off, int len) throws IOException {
/*  56 */     for (; len > 0; len--) write(str.charAt(off++));
/*     */   }
/*     */   
/*     */   public void write(int c) throws IOException {
/*  60 */     if (c == 10) {
/*  61 */       this.lineBuffer.append('\n');
/*  62 */       line(this.lineBuffer.toString());
/*  63 */       this.lineBuffer.setLength(0);
/*  64 */       return;
/*     */     }
/*  66 */     if ((this.lineBuffer.length() > 0) && (this.lineBuffer.charAt(this.lineBuffer.length() - 1) == '\r')) {
/*  67 */       line(this.lineBuffer.toString());
/*  68 */       this.lineBuffer.setCharAt(0, (char)c);
/*  69 */       this.lineBuffer.setLength(1);
/*  70 */       return;
/*     */     }
/*  72 */     this.lineBuffer.append((char)c);
/*     */   }
/*     */   
/*     */   private void line(String line) throws IOException {
/*  76 */     if (this.tabulatorBuffer != null) {
/*  77 */       this.tabulatorBuffer.add(new StringBuffer(line.length()).append(line));
/*  78 */       if (line.charAt(0) == 65533) { this.indentation += 1;line = line.substring(1); }
/*  79 */       if ((line.charAt(0) == 65532) && (--this.indentation < this.tabulatorIndentation)) {
/*  80 */         flushTabulatorBuffer();
/*     */       }
/*     */     }
/*  83 */     else if (line.indexOf(65535) != -1) {
/*  84 */       if (line.charAt(0) == 65533) { this.indentation += 1;line = line.substring(1); }
/*  85 */       if (line.charAt(0) == 65532) { this.indentation -= 1;line = line.substring(1); }
/*  86 */       this.tabulatorBuffer = new ArrayList();
/*  87 */       this.tabulatorBuffer.add(new StringBuffer(line.length()).append(line));
/*  88 */       this.tabulatorIndentation = this.indentation;
/*     */     }
/*     */     else {
/*  91 */       if (line.charAt(0) == 65534) line = line.substring(1);
/*  92 */       if (line.charAt(0) == 65533) { this.indentation += 1;line = line.substring(1); }
/*  93 */       if (line.charAt(0) == 65532) { this.indentation -= 1;line = line.substring(1); }
/*  94 */       if ("\r\n".indexOf(line.charAt(0)) == -1) {
/*  95 */         for (int i = 0; i < this.indentation; i++) this.out.write("    ");
/*     */       }
/*  97 */       this.out.write(line);
/*     */     }
/*     */   }
/*     */   
/*     */   private void flushTabulatorBuffer() throws IOException {
/* 102 */     List lineGroups = new ArrayList();
/* 103 */     lineGroups.add(new ArrayList());
/*     */     
/* 105 */     for (Iterator it = this.tabulatorBuffer.iterator(); it.hasNext();) {
/* 106 */       StringBuffer line = (StringBuffer)it.next();
/* 107 */       int idx = 0;
/* 108 */       if (line.charAt(0) == 65533) {
/* 109 */         lineGroups.add(new ArrayList());
/* 110 */         idx++;
/*     */       }
/* 112 */       if (line.charAt(idx) == 65532) {
/* 113 */         resolveTabs((List)lineGroups.remove(lineGroups.size() - 1));
/* 114 */         idx++;
/*     */       }
/* 116 */       if (line.charAt(idx) == 65534) {
/* 117 */         List lg = (List)lineGroups.get(lineGroups.size() - 1);
/* 118 */         resolveTabs(lg);
/* 119 */         lg.clear();
/* 120 */         line.deleteCharAt(idx);
/*     */       }
/* 122 */       for (int i = 0; i < line.length(); i++) {
/* 123 */         if (line.charAt(i) == 65535) {
/* 124 */           ((List)lineGroups.get(lineGroups.size() - 1)).add(line);
/*     */         }
/*     */       }
/*     */     }
/* 128 */     for (Iterator it = lineGroups.iterator(); it.hasNext();) {
/* 129 */       resolveTabs((List)it.next());
/*     */     }
/* 131 */     int ind = this.tabulatorIndentation;
/* 132 */     for (Iterator it = this.tabulatorBuffer.iterator(); it.hasNext();) {
/* 133 */       String line = ((StringBuffer)it.next()).toString();
/* 134 */       if (line.charAt(0) == 65533) {
/* 135 */         ind++;
/* 136 */         line = line.substring(1);
/*     */       }
/* 138 */       if (line.charAt(0) == 65532) {
/* 139 */         ind--;
/* 140 */         line = line.substring(1);
/*     */       }
/* 142 */       if ("\r\n".indexOf(line.charAt(0)) == -1) {
/* 143 */         for (int i = 0; i < ind; i++) this.out.write("    ");
/*     */       }
/* 145 */       this.out.write(line.toString());
/*     */     }
/* 147 */     this.tabulatorBuffer = null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private void resolveTabs(List lineGroup)
/*     */   {
/* 166 */     List tabulatorOffsets = new ArrayList();
/* 167 */     for (Iterator it = lineGroup.iterator(); it.hasNext();) {
/* 168 */       StringBuffer line = (StringBuffer)it.next();
/* 169 */       int tabCount = 0;
/* 170 */       int previousTab = 0;
/* 171 */       if (line.charAt(previousTab) == 65533) previousTab++;
/* 172 */       if (line.charAt(previousTab) == 65532) previousTab++;
/* 173 */       for (int i = previousTab; i < line.length(); i++) {
/* 174 */         if (line.charAt(i) == 65535) {
/* 175 */           int tabOffset = i - previousTab;
/* 176 */           previousTab = i;
/* 177 */           if (tabCount >= tabulatorOffsets.size()) {
/* 178 */             tabulatorOffsets.add(new Integer(tabOffset));
/*     */ 
/*     */           }
/* 181 */           else if (tabOffset > ((Integer)tabulatorOffsets.get(tabCount)).intValue()) {
/* 182 */             tabulatorOffsets.set(tabCount, new Integer(tabOffset));
/*     */           }
/*     */           
/* 185 */           tabCount++;
/*     */         }
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 191 */     for (Iterator it = lineGroup.iterator(); it.hasNext();) {
/* 192 */       StringBuffer line = (StringBuffer)it.next();
/* 193 */       int tabCount = 0;
/* 194 */       int previousTab = 0;
/* 195 */       if (line.charAt(previousTab) == 65533) previousTab++;
/* 196 */       if (line.charAt(previousTab) == 65532) previousTab++;
/* 197 */       for (int i = previousTab; i < line.length(); i++) {
/* 198 */         if (line.charAt(i) == 65535) {
/* 199 */           int tabOffset = i - previousTab;
/* 200 */           int n = ((Integer)tabulatorOffsets.get(tabCount++)).intValue() - tabOffset;
/* 201 */           line.replace(i, i + 1, spaces(n));
/* 202 */           i += n - 1;
/* 203 */           previousTab = i;
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   private String spaces(int n)
/*     */   {
/* 213 */     if (n < 30) return "                              ".substring(0, n);
/* 214 */     char[] data = new char[n];
/* 215 */     Arrays.fill(data, ' ');
/* 216 */     return String.valueOf(data);
/*     */   }
/*     */   
/*     */   public void close() throws IOException {
/* 220 */     if (this.tabulatorBuffer != null) flushTabulatorBuffer();
/* 221 */     if (this.lineBuffer.length() > 0) line(this.lineBuffer.toString());
/* 222 */     this.out.close();
/*     */   }
/*     */   
/*     */   public void flush() throws IOException {
/* 226 */     this.out.flush();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\util\AutoIndentWriter.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */