/*     */ package org.codehaus.janino.util;
/*     */ 
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import org.codehaus.janino.Java.AnonymousClassDeclaration;
/*     */ import org.codehaus.janino.Java.ArrayAccessExpression;
/*     */ import org.codehaus.janino.Java.ArrayType;
/*     */ import org.codehaus.janino.Java.Assignment;
/*     */ import org.codehaus.janino.Java.Atom;
/*     */ import org.codehaus.janino.Java.BinaryOperation;
/*     */ import org.codehaus.janino.Java.Block;
/*     */ import org.codehaus.janino.Java.BlockStatement;
/*     */ import org.codehaus.janino.Java.Cast;
/*     */ import org.codehaus.janino.Java.ClassLiteral;
/*     */ import org.codehaus.janino.Java.ConditionalExpression;
/*     */ import org.codehaus.janino.Java.ConstructorDeclarator;
/*     */ import org.codehaus.janino.Java.DoStatement;
/*     */ import org.codehaus.janino.Java.FieldAccess;
/*     */ import org.codehaus.janino.Java.FieldDeclaration;
/*     */ import org.codehaus.janino.Java.ForStatement;
/*     */ import org.codehaus.janino.Java.IfStatement;
/*     */ import org.codehaus.janino.Java.Initializer;
/*     */ import org.codehaus.janino.Java.Instanceof;
/*     */ import org.codehaus.janino.Java.LocalClassDeclarationStatement;
/*     */ import org.codehaus.janino.Java.LocalVariableDeclarationStatement;
/*     */ import org.codehaus.janino.Java.MethodDeclarator;
/*     */ import org.codehaus.janino.Java.MethodInvocation;
/*     */ import org.codehaus.janino.Java.NewAnonymousClassInstance;
/*     */ import org.codehaus.janino.Java.NewArray;
/*     */ import org.codehaus.janino.Java.NewClassInstance;
/*     */ import org.codehaus.janino.Java.NewInitializedArray;
/*     */ import org.codehaus.janino.Java.ParenthesizedExpression;
/*     */ import org.codehaus.janino.Java.QualifiedThisReference;
/*     */ import org.codehaus.janino.Java.ReturnStatement;
/*     */ import org.codehaus.janino.Java.Rvalue;
/*     */ import org.codehaus.janino.Java.SuperConstructorInvocation;
/*     */ import org.codehaus.janino.Java.SuperclassFieldAccessExpression;
/*     */ import org.codehaus.janino.Java.SwitchStatement;
/*     */ import org.codehaus.janino.Java.SynchronizedStatement;
/*     */ import org.codehaus.janino.Java.ThrowStatement;
/*     */ import org.codehaus.janino.Java.TryStatement;
/*     */ import org.codehaus.janino.Java.Type;
/*     */ import org.codehaus.janino.Java.UnaryOperation;
/*     */ import org.codehaus.janino.Java.WhileStatement;
/*     */ 
/*     */ public class Traverser
/*     */ {
/*  48 */   private final org.codehaus.janino.Visitor.ComprehensiveVisitor cv = new org.codehaus.janino.Visitor.ComprehensiveVisitor()
/*     */   {
/*  50 */     public final void visitSingleTypeImportDeclaration(org.codehaus.janino.Java.CompilationUnit.SingleTypeImportDeclaration stid) { Traverser.this.traverseSingleTypeImportDeclaration(stid); }
/*  51 */     public final void visitTypeImportOnDemandDeclaration(org.codehaus.janino.Java.CompilationUnit.TypeImportOnDemandDeclaration tiodd) { Traverser.this.traverseTypeImportOnDemandDeclaration(tiodd); }
/*  52 */     public final void visitSingleStaticImportDeclaration(org.codehaus.janino.Java.CompilationUnit.SingleStaticImportDeclaration ssid) { Traverser.this.traverseSingleStaticImportDeclaration(ssid); }
/*  53 */     public final void visitStaticImportOnDemandDeclaration(org.codehaus.janino.Java.CompilationUnit.StaticImportOnDemandDeclaration siodd) { Traverser.this.traverseStaticImportOnDemandDeclaration(siodd); }
/*  54 */     public final void visitAnonymousClassDeclaration(Java.AnonymousClassDeclaration acd) { Traverser.this.traverseAnonymousClassDeclaration(acd); }
/*  55 */     public final void visitLocalClassDeclaration(org.codehaus.janino.Java.LocalClassDeclaration lcd) { Traverser.this.traverseLocalClassDeclaration(lcd); }
/*  56 */     public final void visitPackageMemberClassDeclaration(org.codehaus.janino.Java.PackageMemberClassDeclaration pmcd) { Traverser.this.traversePackageMemberClassDeclaration(pmcd); }
/*  57 */     public final void visitMemberInterfaceDeclaration(org.codehaus.janino.Java.MemberInterfaceDeclaration mid) { Traverser.this.traverseMemberInterfaceDeclaration(mid); }
/*  58 */     public final void visitPackageMemberInterfaceDeclaration(org.codehaus.janino.Java.PackageMemberInterfaceDeclaration pmid) { Traverser.this.traversePackageMemberInterfaceDeclaration(pmid); }
/*  59 */     public final void visitMemberClassDeclaration(org.codehaus.janino.Java.MemberClassDeclaration mcd) { Traverser.this.traverseMemberClassDeclaration(mcd); }
/*  60 */     public final void visitConstructorDeclarator(Java.ConstructorDeclarator cd) { Traverser.this.traverseConstructorDeclarator(cd); }
/*  61 */     public final void visitInitializer(Java.Initializer i) { Traverser.this.traverseInitializer(i); }
/*  62 */     public final void visitMethodDeclarator(Java.MethodDeclarator md) { Traverser.this.traverseMethodDeclarator(md); }
/*  63 */     public final void visitFieldDeclaration(Java.FieldDeclaration fd) { Traverser.this.traverseFieldDeclaration(fd); }
/*  64 */     public final void visitLabeledStatement(org.codehaus.janino.Java.LabeledStatement ls) { Traverser.this.traverseLabeledStatement(ls); }
/*  65 */     public final void visitBlock(Java.Block b) { Traverser.this.traverseBlock(b); }
/*  66 */     public final void visitExpressionStatement(org.codehaus.janino.Java.ExpressionStatement es) { Traverser.this.traverseExpressionStatement(es); }
/*  67 */     public final void visitIfStatement(Java.IfStatement is) { Traverser.this.traverseIfStatement(is); }
/*  68 */     public final void visitForStatement(Java.ForStatement fs) { Traverser.this.traverseForStatement(fs); }
/*  69 */     public final void visitWhileStatement(Java.WhileStatement ws) { Traverser.this.traverseWhileStatement(ws); }
/*  70 */     public final void visitTryStatement(Java.TryStatement ts) { Traverser.this.traverseTryStatement(ts); }
/*  71 */     public final void visitSwitchStatement(Java.SwitchStatement ss) { Traverser.this.traverseSwitchStatement(ss); }
/*  72 */     public final void visitSynchronizedStatement(Java.SynchronizedStatement ss) { Traverser.this.traverseSynchronizedStatement(ss); }
/*  73 */     public final void visitDoStatement(Java.DoStatement ds) { Traverser.this.traverseDoStatement(ds); }
/*  74 */     public final void visitLocalVariableDeclarationStatement(Java.LocalVariableDeclarationStatement lvds) { Traverser.this.traverseLocalVariableDeclarationStatement(lvds); }
/*  75 */     public final void visitReturnStatement(Java.ReturnStatement rs) { Traverser.this.traverseReturnStatement(rs); }
/*  76 */     public final void visitThrowStatement(Java.ThrowStatement ts) { Traverser.this.traverseThrowStatement(ts); }
/*  77 */     public final void visitBreakStatement(org.codehaus.janino.Java.BreakStatement bs) { Traverser.this.traverseBreakStatement(bs); }
/*  78 */     public final void visitContinueStatement(org.codehaus.janino.Java.ContinueStatement cs) { Traverser.this.traverseContinueStatement(cs); }
/*  79 */     public final void visitEmptyStatement(org.codehaus.janino.Java.EmptyStatement es) { Traverser.this.traverseEmptyStatement(es); }
/*  80 */     public final void visitLocalClassDeclarationStatement(Java.LocalClassDeclarationStatement lcds) { Traverser.this.traverseLocalClassDeclarationStatement(lcds); }
/*  81 */     public final void visitPackage(org.codehaus.janino.Java.Package p) { Traverser.this.traversePackage(p); }
/*  82 */     public final void visitArrayLength(org.codehaus.janino.Java.ArrayLength al) { Traverser.this.traverseArrayLength(al); }
/*  83 */     public final void visitAssignment(Java.Assignment a) { Traverser.this.traverseAssignment(a); }
/*  84 */     public final void visitUnaryOperation(Java.UnaryOperation uo) { Traverser.this.traverseUnaryOperation(uo); }
/*  85 */     public final void visitBinaryOperation(Java.BinaryOperation bo) { Traverser.this.traverseBinaryOperation(bo); }
/*  86 */     public final void visitCast(Java.Cast c) { Traverser.this.traverseCast(c); }
/*  87 */     public final void visitClassLiteral(Java.ClassLiteral cl) { Traverser.this.traverseClassLiteral(cl); }
/*  88 */     public final void visitConditionalExpression(Java.ConditionalExpression ce) { Traverser.this.traverseConditionalExpression(ce); }
/*  89 */     public final void visitCrement(org.codehaus.janino.Java.Crement c) { Traverser.this.traverseCrement(c); }
/*  90 */     public final void visitInstanceof(Java.Instanceof io) { Traverser.this.traverseInstanceof(io); }
/*  91 */     public final void visitMethodInvocation(Java.MethodInvocation mi) { Traverser.this.traverseMethodInvocation(mi); }
/*  92 */     public final void visitSuperclassMethodInvocation(org.codehaus.janino.Java.SuperclassMethodInvocation smi) { Traverser.this.traverseSuperclassMethodInvocation(smi); }
/*  93 */     public final void visitLiteral(org.codehaus.janino.Java.Literal l) { Traverser.this.traverseLiteral(l); }
/*  94 */     public final void visitNewAnonymousClassInstance(Java.NewAnonymousClassInstance naci) { Traverser.this.traverseNewAnonymousClassInstance(naci); }
/*  95 */     public final void visitNewArray(Java.NewArray na) { Traverser.this.traverseNewArray(na); }
/*  96 */     public final void visitNewInitializedArray(Java.NewInitializedArray nia) { Traverser.this.traverseNewInitializedArray(nia); }
/*  97 */     public final void visitNewClassInstance(Java.NewClassInstance nci) { Traverser.this.traverseNewClassInstance(nci); }
/*  98 */     public final void visitParameterAccess(org.codehaus.janino.Java.ParameterAccess pa) { Traverser.this.traverseParameterAccess(pa); }
/*  99 */     public final void visitQualifiedThisReference(Java.QualifiedThisReference qtr) { Traverser.this.traverseQualifiedThisReference(qtr); }
/* 100 */     public final void visitThisReference(org.codehaus.janino.Java.ThisReference tr) { Traverser.this.traverseThisReference(tr); }
/* 101 */     public final void visitArrayType(Java.ArrayType at) { Traverser.this.traverseArrayType(at); }
/* 102 */     public final void visitBasicType(org.codehaus.janino.Java.BasicType bt) { Traverser.this.traverseBasicType(bt); }
/* 103 */     public final void visitReferenceType(org.codehaus.janino.Java.ReferenceType rt) { Traverser.this.traverseReferenceType(rt); }
/* 104 */     public final void visitRvalueMemberType(org.codehaus.janino.Java.RvalueMemberType rmt) { Traverser.this.traverseRvalueMemberType(rmt); }
/* 105 */     public final void visitSimpleType(org.codehaus.janino.Java.SimpleType st) { Traverser.this.traverseSimpleType(st); }
/* 106 */     public final void visitAlternateConstructorInvocation(org.codehaus.janino.Java.AlternateConstructorInvocation aci) { Traverser.this.traverseAlternateConstructorInvocation(aci); }
/* 107 */     public final void visitSuperConstructorInvocation(Java.SuperConstructorInvocation sci) { Traverser.this.traverseSuperConstructorInvocation(sci); }
/* 108 */     public final void visitAmbiguousName(org.codehaus.janino.Java.AmbiguousName an) { Traverser.this.traverseAmbiguousName(an); }
/* 109 */     public final void visitArrayAccessExpression(Java.ArrayAccessExpression aae) { Traverser.this.traverseArrayAccessExpression(aae); }
/* 110 */     public final void visitFieldAccess(Java.FieldAccess fa) { Traverser.this.traverseFieldAccess(fa); }
/* 111 */     public final void visitFieldAccessExpression(org.codehaus.janino.Java.FieldAccessExpression fae) { Traverser.this.traverseFieldAccessExpression(fae); }
/* 112 */     public final void visitSuperclassFieldAccessExpression(Java.SuperclassFieldAccessExpression scfae) { Traverser.this.traverseSuperclassFieldAccessExpression(scfae); }
/* 113 */     public final void visitLocalVariableAccess(org.codehaus.janino.Java.LocalVariableAccess lva) { Traverser.this.traverseLocalVariableAccess(lva); }
/* 114 */     public final void visitParenthesizedExpression(Java.ParenthesizedExpression pe) { Traverser.this.traverseParenthesizedExpression(pe); }
/*     */   };
/*     */   
/*     */   public org.codehaus.janino.Visitor.ComprehensiveVisitor comprehensiveVisitor()
/*     */   {
/* 119 */     return this.cv;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void traverseCompilationUnit(org.codehaus.janino.Java.CompilationUnit cu)
/*     */   {
/* 129 */     for (Iterator it = cu.importDeclarations.iterator(); it.hasNext();) {
/* 130 */       ((org.codehaus.janino.Java.CompilationUnit.ImportDeclaration)it.next()).accept(this.cv);
/*     */     }
/* 132 */     for (Iterator it = cu.packageMemberTypeDeclarations.iterator(); it.hasNext();) {
/* 133 */       ((org.codehaus.janino.Java.PackageMemberTypeDeclaration)it.next()).accept(this.cv);
/*     */     }
/*     */   }
/*     */   
/*     */   public void traverseSingleTypeImportDeclaration(org.codehaus.janino.Java.CompilationUnit.SingleTypeImportDeclaration stid) {
/* 138 */     traverseImportDeclaration(stid);
/*     */   }
/*     */   
/*     */   public void traverseTypeImportOnDemandDeclaration(org.codehaus.janino.Java.CompilationUnit.TypeImportOnDemandDeclaration tiodd) {
/* 142 */     traverseImportDeclaration(tiodd);
/*     */   }
/*     */   
/*     */   public void traverseSingleStaticImportDeclaration(org.codehaus.janino.Java.CompilationUnit.SingleStaticImportDeclaration stid) {
/* 146 */     traverseImportDeclaration(stid);
/*     */   }
/*     */   
/*     */   public void traverseStaticImportOnDemandDeclaration(org.codehaus.janino.Java.CompilationUnit.StaticImportOnDemandDeclaration siodd) {
/* 150 */     traverseImportDeclaration(siodd);
/*     */   }
/*     */   
/*     */   public void traverseImportDeclaration(org.codehaus.janino.Java.CompilationUnit.ImportDeclaration id) {
/* 154 */     traverseLocated(id);
/*     */   }
/*     */   
/*     */   public void traverseAnonymousClassDeclaration(Java.AnonymousClassDeclaration acd) {
/* 158 */     acd.baseType.accept(this.cv);
/* 159 */     traverseClassDeclaration(acd);
/*     */   }
/*     */   
/*     */   public void traverseLocalClassDeclaration(org.codehaus.janino.Java.LocalClassDeclaration lcd) {
/* 163 */     traverseNamedClassDeclaration(lcd);
/*     */   }
/*     */   
/*     */   public void traversePackageMemberClassDeclaration(org.codehaus.janino.Java.PackageMemberClassDeclaration pmcd) {
/* 167 */     traverseNamedClassDeclaration(pmcd);
/*     */   }
/*     */   
/*     */   public void traverseMemberInterfaceDeclaration(org.codehaus.janino.Java.MemberInterfaceDeclaration mid) {
/* 171 */     traverseInterfaceDeclaration(mid);
/*     */   }
/*     */   
/*     */   public void traversePackageMemberInterfaceDeclaration(org.codehaus.janino.Java.PackageMemberInterfaceDeclaration pmid) {
/* 175 */     traverseInterfaceDeclaration(pmid);
/*     */   }
/*     */   
/*     */   public void traverseMemberClassDeclaration(org.codehaus.janino.Java.MemberClassDeclaration mcd) {
/* 179 */     traverseNamedClassDeclaration(mcd);
/*     */   }
/*     */   
/*     */   public void traverseConstructorDeclarator(Java.ConstructorDeclarator cd) {
/* 183 */     if (cd.optionalConstructorInvocation != null) {
/* 184 */       cd.optionalConstructorInvocation.accept(this.cv);
/*     */     }
/* 186 */     traverseFunctionDeclarator(cd);
/*     */   }
/*     */   
/*     */   public void traverseInitializer(Java.Initializer i) {
/* 190 */     i.block.accept(this.cv);
/* 191 */     traverseAbstractTypeBodyDeclaration(i);
/*     */   }
/*     */   
/*     */   public void traverseMethodDeclarator(Java.MethodDeclarator md) {
/* 195 */     traverseFunctionDeclarator(md);
/*     */   }
/*     */   
/*     */   public void traverseFieldDeclaration(Java.FieldDeclaration fd) {
/* 199 */     fd.type.accept(this.cv);
/* 200 */     for (int i = 0; i < fd.variableDeclarators.length; i++) {
/* 201 */       org.codehaus.janino.Java.ArrayInitializerOrRvalue optionalInitializer = fd.variableDeclarators[i].optionalInitializer;
/* 202 */       if (optionalInitializer != null) traverseArrayInitializerOrRvalue(optionalInitializer);
/*     */     }
/* 204 */     traverseStatement(fd);
/*     */   }
/*     */   
/*     */   public void traverseLabeledStatement(org.codehaus.janino.Java.LabeledStatement ls) {
/* 208 */     ls.body.accept(this.cv);
/* 209 */     traverseBreakableStatement(ls);
/*     */   }
/*     */   
/*     */   public void traverseBlock(Java.Block b) {
/* 213 */     for (Iterator it = b.statements.iterator(); it.hasNext();) {
/* 214 */       ((org.codehaus.janino.Java.Statement)it.next()).accept(this.cv);
/*     */     }
/* 216 */     traverseStatement(b);
/*     */   }
/*     */   
/*     */   public void traverseExpressionStatement(org.codehaus.janino.Java.ExpressionStatement es) {
/* 220 */     es.rvalue.accept(this.cv);
/* 221 */     traverseStatement(es);
/*     */   }
/*     */   
/*     */   public void traverseIfStatement(Java.IfStatement is) {
/* 225 */     is.condition.accept(this.cv);
/* 226 */     is.thenStatement.accept(this.cv);
/* 227 */     if (is.optionalElseStatement != null) is.optionalElseStatement.accept(this.cv);
/* 228 */     traverseStatement(is);
/*     */   }
/*     */   
/*     */   public void traverseForStatement(Java.ForStatement fs) {
/* 232 */     if (fs.optionalInit != null) fs.optionalInit.accept(this.cv);
/* 233 */     if (fs.optionalCondition != null) fs.optionalCondition.accept(this.cv);
/* 234 */     if (fs.optionalUpdate != null) {
/* 235 */       for (int i = 0; i < fs.optionalUpdate.length; i++) {
/* 236 */         fs.optionalUpdate[i].accept(this.cv);
/*     */       }
/*     */     }
/* 239 */     fs.body.accept(this.cv);
/* 240 */     traverseContinuableStatement(fs);
/*     */   }
/*     */   
/*     */   public void traverseWhileStatement(Java.WhileStatement ws) {
/* 244 */     ws.condition.accept(this.cv);
/* 245 */     ws.body.accept(this.cv);
/* 246 */     traverseContinuableStatement(ws);
/*     */   }
/*     */   
/*     */   public void traverseTryStatement(Java.TryStatement ts) {
/* 250 */     ts.body.accept(this.cv);
/* 251 */     for (Iterator it = ts.catchClauses.iterator(); it.hasNext();) {
/* 252 */       ((org.codehaus.janino.Java.CatchClause)it.next()).body.accept(this.cv);
/*     */     }
/* 254 */     if (ts.optionalFinally != null) ts.optionalFinally.accept(this.cv);
/* 255 */     traverseStatement(ts);
/*     */   }
/*     */   
/*     */   public void traverseSwitchStatement(Java.SwitchStatement ss) {
/* 259 */     ss.condition.accept(this.cv);
/* 260 */     for (Iterator it = ss.sbsgs.iterator(); it.hasNext();) {
/* 261 */       org.codehaus.janino.Java.SwitchStatement.SwitchBlockStatementGroup sbsg = (org.codehaus.janino.Java.SwitchStatement.SwitchBlockStatementGroup)it.next();
/*     */       
/*     */ 
/* 264 */       for (Iterator it2 = sbsg.caseLabels.iterator(); it2.hasNext();) {
/* 265 */         ((Java.Rvalue)it2.next()).accept(this.cv);
/*     */       }
/* 267 */       for (Iterator it2 = sbsg.blockStatements.iterator(); it2.hasNext();) {
/* 268 */         ((Java.BlockStatement)it2.next()).accept(this.cv);
/*     */       }
/* 270 */       traverseLocated(sbsg);
/*     */     }
/* 272 */     traverseBreakableStatement(ss);
/*     */   }
/*     */   
/*     */   public void traverseSynchronizedStatement(Java.SynchronizedStatement ss) {
/* 276 */     ss.expression.accept(this.cv);
/* 277 */     ss.body.accept(this.cv);
/* 278 */     traverseStatement(ss);
/*     */   }
/*     */   
/*     */   public void traverseDoStatement(Java.DoStatement ds) {
/* 282 */     ds.body.accept(this.cv);
/* 283 */     ds.condition.accept(this.cv);
/* 284 */     traverseContinuableStatement(ds);
/*     */   }
/*     */   
/*     */   public void traverseLocalVariableDeclarationStatement(Java.LocalVariableDeclarationStatement lvds) {
/* 288 */     lvds.type.accept(this.cv);
/* 289 */     for (int i = 0; i < lvds.variableDeclarators.length; i++) {
/* 290 */       org.codehaus.janino.Java.ArrayInitializerOrRvalue optionalInitializer = lvds.variableDeclarators[i].optionalInitializer;
/* 291 */       if (optionalInitializer != null) traverseArrayInitializerOrRvalue(optionalInitializer);
/*     */     }
/* 293 */     traverseStatement(lvds);
/*     */   }
/*     */   
/*     */   public void traverseReturnStatement(Java.ReturnStatement rs) {
/* 297 */     if (rs.optionalReturnValue != null) rs.optionalReturnValue.accept(this.cv);
/* 298 */     traverseStatement(rs);
/*     */   }
/*     */   
/*     */   public void traverseThrowStatement(Java.ThrowStatement ts) {
/* 302 */     ts.expression.accept(this.cv);
/* 303 */     traverseStatement(ts);
/*     */   }
/*     */   
/*     */   public void traverseBreakStatement(org.codehaus.janino.Java.BreakStatement bs) {
/* 307 */     traverseStatement(bs);
/*     */   }
/*     */   
/*     */   public void traverseContinueStatement(org.codehaus.janino.Java.ContinueStatement cs) {
/* 311 */     traverseStatement(cs);
/*     */   }
/*     */   
/*     */   public void traverseEmptyStatement(org.codehaus.janino.Java.EmptyStatement es) {
/* 315 */     traverseStatement(es);
/*     */   }
/*     */   
/*     */   public void traverseLocalClassDeclarationStatement(Java.LocalClassDeclarationStatement lcds) {
/* 319 */     lcds.lcd.accept(this.cv);
/* 320 */     traverseStatement(lcds);
/*     */   }
/*     */   
/*     */   public void traversePackage(org.codehaus.janino.Java.Package p) {
/* 324 */     traverseAtom(p);
/*     */   }
/*     */   
/*     */   public void traverseArrayLength(org.codehaus.janino.Java.ArrayLength al) {
/* 328 */     al.lhs.accept(this.cv);
/* 329 */     traverseRvalue(al);
/*     */   }
/*     */   
/*     */   public void traverseAssignment(Java.Assignment a) {
/* 333 */     a.lhs.accept(this.cv);
/* 334 */     a.rhs.accept(this.cv);
/* 335 */     traverseRvalue(a);
/*     */   }
/*     */   
/*     */   public void traverseUnaryOperation(Java.UnaryOperation uo) {
/* 339 */     uo.operand.accept(this.cv);
/* 340 */     traverseBooleanRvalue(uo);
/*     */   }
/*     */   
/*     */   public void traverseBinaryOperation(Java.BinaryOperation bo) {
/* 344 */     bo.lhs.accept(this.cv);
/* 345 */     bo.rhs.accept(this.cv);
/* 346 */     traverseBooleanRvalue(bo);
/*     */   }
/*     */   
/*     */   public void traverseCast(Java.Cast c) {
/* 350 */     c.targetType.accept(this.cv);
/* 351 */     c.value.accept(this.cv);
/* 352 */     traverseRvalue(c);
/*     */   }
/*     */   
/*     */   public void traverseClassLiteral(Java.ClassLiteral cl) {
/* 356 */     cl.type.accept(this.cv);
/* 357 */     traverseRvalue(cl);
/*     */   }
/*     */   
/*     */   public void traverseConditionalExpression(Java.ConditionalExpression ce) {
/* 361 */     ce.lhs.accept(this.cv);
/* 362 */     ce.mhs.accept(this.cv);
/* 363 */     ce.rhs.accept(this.cv);
/* 364 */     traverseRvalue(ce);
/*     */   }
/*     */   
/*     */   public void traverseCrement(org.codehaus.janino.Java.Crement c) {
/* 368 */     c.operand.accept(this.cv);
/* 369 */     traverseRvalue(c);
/*     */   }
/*     */   
/*     */   public void traverseInstanceof(Java.Instanceof io) {
/* 373 */     io.lhs.accept(this.cv);
/* 374 */     io.rhs.accept(this.cv);
/* 375 */     traverseRvalue(io);
/*     */   }
/*     */   
/*     */   public void traverseMethodInvocation(Java.MethodInvocation mi) {
/* 379 */     if (mi.optionalTarget != null) mi.optionalTarget.accept(this.cv);
/* 380 */     traverseInvocation(mi);
/*     */   }
/*     */   
/*     */   public void traverseSuperclassMethodInvocation(org.codehaus.janino.Java.SuperclassMethodInvocation smi) {
/* 384 */     traverseInvocation(smi);
/*     */   }
/*     */   
/*     */   public void traverseLiteral(org.codehaus.janino.Java.Literal l) {
/* 388 */     traverseRvalue(l);
/*     */   }
/*     */   
/*     */   public void traverseNewAnonymousClassInstance(Java.NewAnonymousClassInstance naci) {
/* 392 */     if (naci.optionalQualification != null) naci.optionalQualification.accept(this.cv);
/* 393 */     naci.anonymousClassDeclaration.accept(this.cv);
/* 394 */     for (int i = 0; i < naci.arguments.length; i++) naci.arguments[i].accept(this.cv);
/* 395 */     traverseRvalue(naci);
/*     */   }
/*     */   
/*     */   public void traverseNewArray(Java.NewArray na) {
/* 399 */     na.type.accept(this.cv);
/* 400 */     for (int i = 0; i < na.dimExprs.length; i++) na.dimExprs[i].accept(this.cv);
/* 401 */     traverseRvalue(na);
/*     */   }
/*     */   
/*     */   public void traverseNewInitializedArray(Java.NewInitializedArray nia) {
/* 405 */     nia.arrayType.accept(this.cv);
/* 406 */     traverseArrayInitializerOrRvalue(nia.arrayInitializer);
/*     */   }
/*     */   
/*     */   public void traverseArrayInitializerOrRvalue(org.codehaus.janino.Java.ArrayInitializerOrRvalue aiorv) {
/* 410 */     if ((aiorv instanceof Java.Rvalue)) {
/* 411 */       ((Java.Atom)aiorv).accept(this.cv);
/*     */     }
/* 413 */     else if ((aiorv instanceof org.codehaus.janino.Java.ArrayInitializer)) {
/* 414 */       org.codehaus.janino.Java.ArrayInitializerOrRvalue[] values = ((org.codehaus.janino.Java.ArrayInitializer)aiorv).values;
/* 415 */       for (int i = 0; i < values.length; i++) traverseArrayInitializerOrRvalue(values[i]);
/*     */     }
/*     */     else {
/* 418 */       throw new org.codehaus.janino.JaninoRuntimeException("Unexpected array initializer or rvalue class " + aiorv.getClass().getName());
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   public void traverseNewClassInstance(Java.NewClassInstance nci)
/*     */   {
/* 425 */     if (nci.optionalQualification != null) nci.optionalQualification.accept(this.cv);
/* 426 */     nci.type.accept(this.cv);
/* 427 */     for (int i = 0; i < nci.arguments.length; i++) nci.arguments[i].accept(this.cv);
/* 428 */     traverseRvalue(nci);
/*     */   }
/*     */   
/*     */   public void traverseParameterAccess(org.codehaus.janino.Java.ParameterAccess pa) {
/* 432 */     traverseRvalue(pa);
/*     */   }
/*     */   
/*     */   public void traverseQualifiedThisReference(Java.QualifiedThisReference qtr) {
/* 436 */     qtr.qualification.accept(this.cv);
/* 437 */     traverseRvalue(qtr);
/*     */   }
/*     */   
/*     */   public void traverseThisReference(org.codehaus.janino.Java.ThisReference tr) {
/* 441 */     traverseRvalue(tr);
/*     */   }
/*     */   
/*     */   public void traverseArrayType(Java.ArrayType at) {
/* 445 */     at.componentType.accept(this.cv);
/* 446 */     traverseType(at);
/*     */   }
/*     */   
/*     */   public void traverseBasicType(org.codehaus.janino.Java.BasicType bt) {
/* 450 */     traverseType(bt);
/*     */   }
/*     */   
/*     */   public void traverseReferenceType(org.codehaus.janino.Java.ReferenceType rt) {
/* 454 */     traverseType(rt);
/*     */   }
/*     */   
/*     */   public void traverseRvalueMemberType(org.codehaus.janino.Java.RvalueMemberType rmt) {
/* 458 */     rmt.rvalue.accept(this.cv);
/* 459 */     traverseType(rmt);
/*     */   }
/*     */   
/*     */   public void traverseSimpleType(org.codehaus.janino.Java.SimpleType st) {
/* 463 */     traverseType(st);
/*     */   }
/*     */   
/*     */   public void traverseAlternateConstructorInvocation(org.codehaus.janino.Java.AlternateConstructorInvocation aci) {
/* 467 */     traverseConstructorInvocation(aci);
/*     */   }
/*     */   
/*     */   public void traverseSuperConstructorInvocation(Java.SuperConstructorInvocation sci) {
/* 471 */     if (sci.optionalQualification != null) sci.optionalQualification.accept(this.cv);
/* 472 */     traverseConstructorInvocation(sci);
/*     */   }
/*     */   
/*     */   public void traverseAmbiguousName(org.codehaus.janino.Java.AmbiguousName an) {
/* 476 */     traverseLvalue(an);
/*     */   }
/*     */   
/*     */   public void traverseArrayAccessExpression(Java.ArrayAccessExpression aae) {
/* 480 */     aae.lhs.accept(this.cv);
/* 481 */     aae.index.accept(this.cv);
/* 482 */     traverseLvalue(aae);
/*     */   }
/*     */   
/*     */   public void traverseFieldAccess(Java.FieldAccess fa) {
/* 486 */     fa.lhs.accept(this.cv);
/* 487 */     traverseLvalue(fa);
/*     */   }
/*     */   
/*     */   public void traverseFieldAccessExpression(org.codehaus.janino.Java.FieldAccessExpression fae) {
/* 491 */     fae.lhs.accept(this.cv);
/* 492 */     traverseLvalue(fae);
/*     */   }
/*     */   
/*     */   public void traverseSuperclassFieldAccessExpression(Java.SuperclassFieldAccessExpression scfae) {
/* 496 */     if (scfae.optionalQualification != null) scfae.optionalQualification.accept(this.cv);
/* 497 */     traverseLvalue(scfae);
/*     */   }
/*     */   
/*     */   public void traverseLocalVariableAccess(org.codehaus.janino.Java.LocalVariableAccess lva) {
/* 501 */     traverseLvalue(lva);
/*     */   }
/*     */   
/*     */   public void traverseParenthesizedExpression(Java.ParenthesizedExpression pe) {
/* 505 */     pe.value.accept(this.cv);
/* 506 */     traverseLvalue(pe);
/*     */   }
/*     */   
/*     */   public void traverseClassDeclaration(org.codehaus.janino.Java.ClassDeclaration cd) {
/* 510 */     for (Iterator it = cd.constructors.iterator(); it.hasNext();) {
/* 511 */       ((Java.ConstructorDeclarator)it.next()).accept(this.cv);
/*     */     }
/* 513 */     for (Iterator it = cd.variableDeclaratorsAndInitializers.iterator(); it.hasNext();) {
/* 514 */       ((org.codehaus.janino.Java.TypeBodyDeclaration)it.next()).accept(this.cv);
/*     */     }
/* 516 */     traverseAbstractTypeDeclaration(cd);
/*     */   }
/*     */   
/*     */   public void traverseAbstractTypeDeclaration(org.codehaus.janino.Java.AbstractTypeDeclaration atd) {
/* 520 */     for (Iterator it = atd.getMemberTypeDeclarations().iterator(); it.hasNext();) {
/* 521 */       ((org.codehaus.janino.Java.NamedTypeDeclaration)it.next()).accept(this.cv);
/*     */     }
/* 523 */     for (Iterator it = atd.getMethodDeclarations().iterator(); it.hasNext();) {
/* 524 */       traverseMethodDeclarator((Java.MethodDeclarator)it.next());
/*     */     }
/*     */   }
/*     */   
/*     */   public void traverseNamedClassDeclaration(org.codehaus.janino.Java.NamedClassDeclaration ncd) {
/* 529 */     for (int i = 0; i < ncd.implementedTypes.length; i++) {
/* 530 */       ncd.implementedTypes[i].accept(this.cv);
/*     */     }
/* 532 */     if (ncd.optionalExtendedType != null) ncd.optionalExtendedType.accept(this.cv);
/* 533 */     traverseClassDeclaration(ncd);
/*     */   }
/*     */   
/*     */   public void traverseInterfaceDeclaration(org.codehaus.janino.Java.InterfaceDeclaration id) {
/* 537 */     for (Iterator it = id.constantDeclarations.iterator(); it.hasNext();) {
/* 538 */       ((org.codehaus.janino.Java.TypeBodyDeclaration)it.next()).accept(this.cv);
/*     */     }
/* 540 */     for (int i = 0; i < id.extendedTypes.length; i++) {
/* 541 */       id.extendedTypes[i].accept(this.cv);
/*     */     }
/* 543 */     traverseAbstractTypeDeclaration(id);
/*     */   }
/*     */   
/*     */   public void traverseFunctionDeclarator(org.codehaus.janino.Java.FunctionDeclarator fd) {
/* 547 */     for (int i = 0; i < fd.formalParameters.length; i++)
/* 548 */       fd.formalParameters[i].type.accept(this.cv);
/*     */     Iterator it;
/* 550 */     if (fd.optionalStatements != null) {
/* 551 */       for (it = fd.optionalStatements.iterator(); it.hasNext();) {
/* 552 */         Java.BlockStatement bs = (Java.BlockStatement)it.next();
/* 553 */         bs.accept(this.cv);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public void traverseAbstractTypeBodyDeclaration(org.codehaus.janino.Java.AbstractTypeBodyDeclaration atbd) {
/* 559 */     traverseLocated(atbd);
/*     */   }
/*     */   
/*     */   public void traverseStatement(org.codehaus.janino.Java.Statement s) {
/* 563 */     traverseLocated(s);
/*     */   }
/*     */   
/*     */   public void traverseBreakableStatement(org.codehaus.janino.Java.BreakableStatement bs) {
/* 567 */     traverseStatement(bs);
/*     */   }
/*     */   
/*     */   public void traverseContinuableStatement(org.codehaus.janino.Java.ContinuableStatement cs) {
/* 571 */     traverseBreakableStatement(cs);
/*     */   }
/*     */   
/*     */   public void traverseRvalue(Java.Rvalue rv) {
/* 575 */     traverseAtom(rv);
/*     */   }
/*     */   
/*     */   public void traverseBooleanRvalue(org.codehaus.janino.Java.BooleanRvalue brv) {
/* 579 */     traverseRvalue(brv);
/*     */   }
/*     */   
/*     */   public void traverseInvocation(org.codehaus.janino.Java.Invocation i) {
/* 583 */     for (int j = 0; j < i.arguments.length; j++) i.arguments[j].accept(this.cv);
/* 584 */     traverseRvalue(i);
/*     */   }
/*     */   
/*     */   public void traverseConstructorInvocation(org.codehaus.janino.Java.ConstructorInvocation ci) {
/* 588 */     for (int i = 0; i < ci.arguments.length; i++) ci.arguments[i].accept(this.cv);
/* 589 */     traverseAtom(ci);
/*     */   }
/*     */   
/*     */   public void traverseLvalue(org.codehaus.janino.Java.Lvalue lv) {
/* 593 */     traverseRvalue(lv);
/*     */   }
/*     */   
/*     */   public void traverseType(Java.Type t) {
/* 597 */     traverseAtom(t);
/*     */   }
/*     */   
/*     */   public void traverseAtom(Java.Atom a) {
/* 601 */     traverseLocated(a);
/*     */   }
/*     */   
/*     */   public void traverseLocated(org.codehaus.janino.Java.Located l) {}
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\util\Traverser.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */