/*    */ package com.netapp.asup.data.function.aggregation;
/*    */ 
/*    */ import com.netapp.asup.client.arma.data.ARMAObjectInstance;
/*    */ import com.netapp.asup.data.function.Function;
/*    */ import com.netapp.asup.exception.ARMAException;
/*    */ import java.util.HashMap;
/*    */ import java.util.Map;
/*    */ import java.util.Map.Entry;
/*    */ import org.apache.avro.Schema;
/*    */ import org.apache.avro.generic.GenericRecord;
/*    */ import org.apache.avro.util.Utf8;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class AggregateFunction
/*    */   implements Function
/*    */ {
/*    */   public GenericRecord execute(ARMAObjectInstance instance, GenericRecord input, Schema outputSchema)
/*    */     throws Exception
/*    */   {
/* 23 */     Map<Utf8, Map<Utf8, GenericRecord>> inputMap = (Map)input.get("field");
/* 24 */     for (Map.Entry<Utf8, Map<Utf8, GenericRecord>> inputEntry : inputMap.entrySet()) {
/* 25 */       Utf8 path = (Utf8)inputEntry.getKey();
/* 26 */       String[] objects = path.toString().split("/");
/*    */       
/* 28 */       ARMAPathInstanceIterator iterator = new ARMAPathInstanceIterator(instance, objects);
/* 29 */       Map<String, Aggregator<?>> aggregators = initializeFieldAggregators((Map)inputEntry.getValue());
/*    */       ARMAObjectInstance childInstance;
/* 31 */       while (iterator.hasNext()) {
/* 32 */         childInstance = iterator.next();
/* 33 */         for (Aggregator<?> aggregator : aggregators.values()) {
/* 34 */           aggregator.compute(childInstance);
/*    */         }
/*    */       }
/* 37 */       for (Map.Entry<String, Aggregator<?>> aggregatorEntry : aggregators.entrySet()) {
/* 38 */         instance.addDerviedAttribute(((String)aggregatorEntry.getKey()).toString(), ((Aggregator)aggregatorEntry.getValue()).getResult());
/*    */       }
/*    */     }
/*    */     
/*    */ 
/* 43 */     return null;
/*    */   }
/*    */   
/*    */   private Map<String, Aggregator<?>> initializeFieldAggregators(Map<Utf8, GenericRecord> derivedAttributeMap) throws ARMAException {
/* 47 */     Map<String, Aggregator<?>> aggregators = new HashMap();
/* 48 */     for (Map.Entry<Utf8, GenericRecord> derivedAttributeEntry : derivedAttributeMap.entrySet()) {
/* 49 */       aggregators.put(((Utf8)derivedAttributeEntry.getKey()).toString(), Aggregator.getAggregator((GenericRecord)derivedAttributeEntry.getValue()));
/*    */     }
/* 51 */     return aggregators;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\function\aggregation\AggregateFunction.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */