/*    */ package com.netapp.asup.data.objects;
/*    */ 
/*    */ import java.io.IOException;
/*    */ import java.nio.ByteBuffer;
/*    */ import java.util.List;
/*    */ import org.apache.avro.Schema;
/*    */ import org.apache.avro.generic.GenericData.Array;
/*    */ import org.apache.avro.generic.GenericData.Record;
/*    */ import org.apache.avro.generic.GenericRecord;
/*    */ 
/*    */ 
/*    */ 
/*    */ public class PerfCounterData
/*    */   extends ByteWrappedGenericRecord<GenericRecord, GenericRecord>
/*    */ {
/*    */   private String objectName;
/*    */   private static final String OBJECT_NAME_FIELD = "objectName";
/*    */   private static final String OBJECT_DATA_FIELD = "objectData";
/*    */   private static final String TIMESTAMPS_FIELD = "timestamps";
/*    */   private final GenericRecord counterObjectData;
/*    */   
/*    */   public PerfCounterData(GenericRecord object, Schema readerSchema, Schema writerSchema, String objName, String id)
/*    */     throws IOException
/*    */   {
/* 25 */     super(ARMASchema.PERFCOUNTERDATA, writerSchema, readerSchema, id);
/* 26 */     this.counterObjectData = ((GenericRecord)deserializeData((byte[])object.get("objectData")));
/* 27 */     this.objectName = objName;
/*    */   }
/*    */   
/*    */   public PerfCounterData(byte[] data, Schema readerSchema, Schema writerSchema, String objName, String id) throws IOException
/*    */   {
/* 32 */     super(ARMASchema.PERFCOUNTERDATA, writerSchema, readerSchema, id);
/* 33 */     this.counterObjectData = ((GenericRecord)deserializeData(data));
/* 34 */     this.objectName = objName;
/*    */   }
/*    */   
/*    */   public GenericRecord getObject() throws IOException
/*    */   {
/* 39 */     ByteBuffer serializedData = ByteBuffer.wrap(serializeData(this.counterObjectData));
/* 40 */     GenericRecord objectRecord = new GenericData.Record(ARMASchema.PERFCOUNTERDATA.getSchema());
/* 41 */     objectRecord.put("objectName", this.objectName);
/* 42 */     objectRecord.put("objectData", serializedData);
/* 43 */     return objectRecord;
/*    */   }
/*    */   
/*    */   public GenericRecord getCounterData()
/*    */   {
/* 48 */     return this.counterObjectData;
/*    */   }
/*    */   
/*    */ 
/*    */   public List<Long> getTimeStamps()
/*    */   {
/* 54 */     return (GenericData.Array)this.counterObjectData.get("timestamps");
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\objects\PerfCounterData.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */