/*    */ package com.sun.xml.bind.v2.runtime.property;
/*    */ 
/*    */ import com.sun.xml.bind.api.AccessorException;
/*    */ import com.sun.xml.bind.v2.model.core.PropertyKind;
/*    */ import com.sun.xml.bind.v2.model.runtime.RuntimeValuePropertyInfo;
/*    */ import com.sun.xml.bind.v2.runtime.JAXBContextImpl;
/*    */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*    */ import com.sun.xml.bind.v2.runtime.reflect.Accessor;
/*    */ import com.sun.xml.bind.v2.runtime.reflect.TransducedAccessor;
/*    */ import com.sun.xml.bind.v2.runtime.unmarshaller.ChildLoader;
/*    */ import com.sun.xml.bind.v2.runtime.unmarshaller.ValuePropertyLoader;
/*    */ import com.sun.xml.bind.v2.util.QNameMap;
/*    */ import java.io.IOException;
/*    */ import javax.xml.stream.XMLStreamException;
/*    */ import org.xml.sax.SAXException;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public final class ValueProperty<BeanT>
/*    */   extends PropertyImpl<BeanT>
/*    */ {
/*    */   private final TransducedAccessor<BeanT> xacc;
/*    */   private final Accessor<BeanT, ?> acc;
/*    */   
/*    */   public ValueProperty(JAXBContextImpl grammar, RuntimeValuePropertyInfo prop)
/*    */   {
/* 40 */     super(grammar, prop);
/* 41 */     this.xacc = TransducedAccessor.get(prop);
/* 42 */     this.acc = prop.getAccessor();
/*    */   }
/*    */   
/*    */   public final void serializeBody(BeanT o, XMLSerializer w, Object outerPeer) throws SAXException, AccessorException, IOException, XMLStreamException {
/* 46 */     if (this.xacc.hasValue(o))
/* 47 */       this.xacc.writeText(w, o, this.fieldName);
/*    */   }
/*    */   
/*    */   public void serializeURIs(BeanT o, XMLSerializer w) throws SAXException, AccessorException {
/* 51 */     this.xacc.declareNamespace(o, w);
/*    */   }
/*    */   
/*    */   public boolean hasSerializeURIAction() {
/* 55 */     return this.xacc.useNamespace();
/*    */   }
/*    */   
/*    */   public void buildChildElementUnmarshallers(UnmarshallerChain chainElem, QNameMap<ChildLoader> handlers) {
/* 59 */     handlers.put(StructureLoaderBuilder.TEXT_HANDLER, new ChildLoader(new ValuePropertyLoader(this.xacc), null));
/*    */   }
/*    */   
/*    */   public PropertyKind getKind()
/*    */   {
/* 64 */     return PropertyKind.VALUE;
/*    */   }
/*    */   
/*    */   public void reset(BeanT o) throws AccessorException {
/* 68 */     this.acc.set(o, null);
/*    */   }
/*    */   
/*    */   public String getIdValue(BeanT bean) throws AccessorException, SAXException {
/* 72 */     return this.xacc.print(bean).toString();
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\property\ValueProperty.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */