/*    */ package org.codehaus.commons.compiler.samples;
/*    */ 
/*    */ import java.io.FileReader;
/*    */ import java.io.IOException;
/*    */ import java.io.PrintStream;
/*    */ import java.io.Reader;
/*    */ import java.lang.reflect.Method;
/*    */ import org.codehaus.commons.compiler.CompilerFactoryFactory;
/*    */ import org.codehaus.commons.compiler.IClassBodyEvaluator;
/*    */ import org.codehaus.commons.compiler.ICompilerFactory;
/*    */ import org.codehaus.commons.compiler.ICookable;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public final class ClassBodyDemo
/*    */ {
/*    */   public static void main(String[] args)
/*    */     throws Exception
/*    */   {
/* 39 */     if ((args.length > 0) && (args[0].equals("-help"))) {
/* 40 */       System.out.println("Usage:");
/* 41 */       System.out.println("  ClassBodyDemo <class-body> { <argument> }");
/* 42 */       System.out.println("  ClassBodyDemo -help");
/* 43 */       System.out.println("If <class-body> starts with a '@', then the class body is read");
/* 44 */       System.out.println("from the named file.");
/* 45 */       System.out.println("The <class-body> must declare a method \"public static main(String[])\"");
/* 46 */       System.out.println("to which the <argument>s are passed. If the return type of that method is");
/* 47 */       System.out.println("not VOID, then the returned value is printed to STDOUT.");
/* 48 */       System.exit(0);
/*    */     }
/*    */     
/* 51 */     int i = 0;
/*    */     
/*    */ 
/* 54 */     if (i >= args.length) {
/* 55 */       System.err.println("Class body missing; try \"-help\".");
/*    */     }
/* 57 */     String classBody = args[(i++)];
/* 58 */     if (classBody.startsWith("@")) { classBody = readFileToString(classBody.substring(1));
/*    */     }
/*    */     
/* 61 */     String[] arguments = new String[args.length - i];
/* 62 */     System.arraycopy(args, i, arguments, 0, arguments.length);
/*    */     
/*    */ 
/* 65 */     IClassBodyEvaluator cbe = CompilerFactoryFactory.getDefaultCompilerFactory().newClassBodyEvaluator();
/* 66 */     cbe.cook(classBody);
/* 67 */     Class c = cbe.getClazz();
/*    */     
/*    */ 
/* 70 */     Method m = c.getMethod("main", new Class[] { new String[0].getClass() });
/* 71 */     Object returnValue = m.invoke(null, new Object[] { arguments });
/*    */     
/*    */ 
/* 74 */     if (m.getReturnType() != Void.TYPE) System.out.println(DemoBase.toString(returnValue));
/*    */   }
/*    */   
/*    */   private static String readFileToString(String fileName)
/*    */     throws IOException
/*    */   {
/* 80 */     Reader r = new FileReader(fileName);
/*    */     try {
/* 82 */       StringBuffer sb = new StringBuffer();
/* 83 */       char[] ca = new char['Ѐ'];
/*    */       int cnt;
/* 85 */       for (;;) { cnt = r.read(ca, 0, ca.length);
/* 86 */         if (cnt == -1) break;
/* 87 */         sb.append(ca, 0, cnt);
/*    */       }
/* 89 */       return sb.toString();
/*    */     } finally {
/* 91 */       r.close();
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\commons\compiler\samples\ClassBodyDemo.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */