/*    */ package org.codehaus.commons.compiler.samples;
/*    */ 
/*    */ import java.io.PrintStream;
/*    */ import org.codehaus.commons.compiler.CompilerFactoryFactory;
/*    */ import org.codehaus.commons.compiler.ICompilerFactory;
/*    */ import org.codehaus.commons.compiler.ICookable;
/*    */ import org.codehaus.commons.compiler.IExpressionEvaluator;
/*    */ import org.codehaus.commons.compiler.IScriptEvaluator;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public final class ShippingCost
/*    */ {
/*    */   public static void main(String[] args)
/*    */     throws Exception
/*    */   {
/* 40 */     if (args.length != 1) {
/* 41 */       System.err.println("Usage: <total>");
/* 42 */       System.err.println("Computes the shipping costs from the double value \"total\".");
/* 43 */       System.err.println("If \"total\" is less than 100.0, then the result is 7.95, else the result is 0.");
/* 44 */       System.exit(1);
/*    */     }
/*    */     
/*    */ 
/* 48 */     Object[] arguments = { new Double(args[0]) };
/*    */     
/*    */ 
/* 51 */     IExpressionEvaluator ee = CompilerFactoryFactory.getDefaultCompilerFactory().newExpressionEvaluator();
/* 52 */     ee.setExpressionType(Double.TYPE);
/* 53 */     ee.setParameters(new String[] { "total" }, new Class[] { Double.TYPE });
/* 54 */     ee.cook("total >= 100.0 ? 0.0 : 7.95");
/*    */     
/*    */ 
/* 57 */     Object res = ee.evaluate(arguments);
/*    */     
/*    */ 
/* 60 */     System.out.println("Result = " + (res == null ? "(null)" : res.toString()));
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\commons\compiler\samples\ShippingCost.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */