/*     */ package org.codehaus.jackson.map.jsontype.impl;
/*     */ 
/*     */ import java.util.EnumMap;
/*     */ import java.util.EnumSet;
/*     */ import org.codehaus.jackson.annotate.JsonTypeInfo.Id;
/*     */ import org.codehaus.jackson.map.type.TypeFactory;
/*     */ import org.codehaus.jackson.map.util.ClassUtil;
/*     */ import org.codehaus.jackson.type.JavaType;
/*     */ 
/*     */ public class ClassNameIdResolver extends TypeIdResolverBase
/*     */ {
/*     */   public ClassNameIdResolver(JavaType baseType, TypeFactory typeFactory)
/*     */   {
/*  14 */     super(baseType, typeFactory);
/*     */   }
/*     */   
/*  17 */   public JsonTypeInfo.Id getMechanism() { return JsonTypeInfo.Id.CLASS; }
/*     */   
/*     */ 
/*     */ 
/*     */   public void registerSubtype(Class<?> type, String name) {}
/*     */   
/*     */ 
/*     */   public String idFromValue(Object value)
/*     */   {
/*  26 */     return _idFrom(value, value.getClass());
/*     */   }
/*     */   
/*     */ 
/*     */   public String idFromValueAndType(Object value, Class<?> type)
/*     */   {
/*  32 */     return _idFrom(value, type);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public JavaType typeFromId(String id)
/*     */   {
/*  41 */     if (id.indexOf('<') > 0) {
/*  42 */       JavaType t = TypeFactory.fromCanonical(id);
/*     */       
/*  44 */       return t;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */     try
/*     */     {
/*  51 */       ClassLoader loader = Thread.currentThread().getContextClassLoader();
/*  52 */       Class<?> cls = Class.forName(id, true, loader);
/*  53 */       return this._typeFactory.constructSpecializedType(this._baseType, cls);
/*     */     } catch (ClassNotFoundException e) {
/*  55 */       throw new IllegalArgumentException("Invalid type id '" + id + "' (for id type 'Id.class'): no such class found");
/*     */     } catch (Exception e) {
/*  57 */       throw new IllegalArgumentException("Invalid type id '" + id + "' (for id type 'Id.class'): " + e.getMessage(), e);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final String _idFrom(Object value, Class<?> cls)
/*     */   {
/*  70 */     if ((Enum.class.isAssignableFrom(cls)) && 
/*  71 */       (!cls.isEnum())) {
/*  72 */       cls = cls.getSuperclass();
/*     */     }
/*     */     
/*  75 */     String str = cls.getName();
/*  76 */     if (str.startsWith("java.util"))
/*     */     {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  85 */       if ((value instanceof EnumSet)) {
/*  86 */         Class<?> enumClass = ClassUtil.findEnumType((EnumSet)value);
/*     */         
/*  88 */         str = TypeFactory.defaultInstance().constructCollectionType(EnumSet.class, enumClass).toCanonical();
/*  89 */       } else if ((value instanceof EnumMap)) {
/*  90 */         Class<?> enumClass = ClassUtil.findEnumType((EnumMap)value);
/*  91 */         Class<?> valueClass = Object.class;
/*     */         
/*  93 */         str = TypeFactory.defaultInstance().constructMapType(EnumMap.class, enumClass, valueClass).toCanonical();
/*     */       } else {
/*  95 */         String end = str.substring(9);
/*  96 */         if (((end.startsWith(".Arrays$")) || (end.startsWith(".Collections$"))) && (str.indexOf("List") >= 0))
/*     */         {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 104 */           str = "java.util.ArrayList";
/*     */         }
/*     */       }
/*     */     }
/* 108 */     return str;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\jsontype\impl\ClassNameIdResolver.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */