/*     */ package org.codehaus.jackson.type;
/*     */ 
/*     */ import java.lang.reflect.Modifier;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class JavaType
/*     */ {
/*     */   protected final Class<?> _class;
/*     */   protected final int _hashCode;
/*     */   protected Object _valueHandler;
/*     */   protected Object _typeHandler;
/*     */   
/*     */   protected JavaType(Class<?> clz, int hash)
/*     */   {
/*  56 */     this._class = clz;
/*  57 */     String name = clz.getName();
/*  58 */     this._hashCode = (name.hashCode() + hash);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract JavaType withTypeHandler(Object paramObject);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract JavaType withContentTypeHandler(Object paramObject);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final JavaType narrowBy(Class<?> subclass)
/*     */   {
/*  93 */     if (subclass == this._class) {
/*  94 */       return this;
/*     */     }
/*     */     
/*  97 */     _assertSubclass(subclass, this._class);
/*  98 */     JavaType result = _narrow(subclass);
/*  99 */     if (this._valueHandler != null) {
/* 100 */       result.setValueHandler(this._valueHandler);
/*     */     }
/* 102 */     if (this._typeHandler != null) {
/* 103 */       result = result.withTypeHandler(this._typeHandler);
/*     */     }
/* 105 */     return result;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final JavaType forcedNarrowBy(Class<?> subclass)
/*     */   {
/* 117 */     if (subclass == this._class) {
/* 118 */       return this;
/*     */     }
/* 120 */     JavaType result = _narrow(subclass);
/* 121 */     if (this._valueHandler != null) {
/* 122 */       result.setValueHandler(this._valueHandler);
/*     */     }
/* 124 */     if (this._typeHandler != null) {
/* 125 */       result = result.withTypeHandler(this._typeHandler);
/*     */     }
/* 127 */     return result;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final JavaType widenBy(Class<?> superclass)
/*     */   {
/* 142 */     if (superclass == this._class) {
/* 143 */       return this;
/*     */     }
/*     */     
/* 146 */     _assertSubclass(this._class, superclass);
/* 147 */     return _widen(superclass);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected abstract JavaType _narrow(Class<?> paramClass);
/*     */   
/*     */ 
/*     */ 
/*     */   protected JavaType _widen(Class<?> superclass)
/*     */   {
/* 158 */     return _narrow(superclass);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract JavaType narrowContentsBy(Class<?> paramClass);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract JavaType widenContentsBy(Class<?> paramClass);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setValueHandler(Object h)
/*     */   {
/* 176 */     if ((h != null) && (this._valueHandler != null)) {
/* 177 */       throw new IllegalStateException("Trying to reset value handler for type [" + toString() + "]; old handler of type " + this._valueHandler.getClass().getName() + ", new handler of type " + h.getClass().getName());
/*     */     }
/*     */     
/* 180 */     this._valueHandler = h;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @Deprecated
/*     */   public void setTypeHandler(Object h)
/*     */   {
/* 200 */     if ((h != null) && (this._typeHandler != null)) {
/* 201 */       throw new IllegalStateException("Trying to reset type handler for type [" + toString() + "]; old handler of type " + this._typeHandler.getClass().getName() + ", new handler of type " + h.getClass().getName());
/*     */     }
/*     */     
/* 204 */     this._typeHandler = h;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final Class<?> getRawClass()
/*     */   {
/* 213 */     return this._class;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public final boolean hasRawClass(Class<?> clz)
/*     */   {
/* 221 */     return this._class == clz;
/*     */   }
/*     */   
/*     */   public boolean isAbstract() {
/* 225 */     return Modifier.isAbstract(this._class.getModifiers());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public boolean isConcrete()
/*     */   {
/* 232 */     int mod = this._class.getModifiers();
/* 233 */     if ((mod & 0x600) == 0) {
/* 234 */       return true;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/* 239 */     if (this._class.isPrimitive()) {
/* 240 */       return true;
/*     */     }
/* 242 */     return false;
/*     */   }
/*     */   
/*     */   public boolean isThrowable() {
/* 246 */     return Throwable.class.isAssignableFrom(this._class);
/*     */   }
/*     */   
/* 249 */   public boolean isArrayType() { return false; }
/*     */   
/* 251 */   public final boolean isEnumType() { return this._class.isEnum(); }
/*     */   
/* 253 */   public final boolean isInterface() { return this._class.isInterface(); }
/*     */   
/* 255 */   public final boolean isPrimitive() { return this._class.isPrimitive(); }
/*     */   
/* 257 */   public final boolean isFinal() { return Modifier.isFinal(this._class.getModifiers()); }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract boolean isContainerType();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isCollectionLikeType()
/*     */   {
/* 272 */     return false;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isMapLikeType()
/*     */   {
/* 281 */     return false;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean hasGenericTypes()
/*     */   {
/* 297 */     return containedTypeCount() > 0;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public JavaType getKeyType()
/*     */   {
/* 304 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public JavaType getContentType()
/*     */   {
/* 311 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public int containedTypeCount()
/*     */   {
/* 320 */     return 0;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public JavaType containedType(int index)
/*     */   {
/* 333 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String containedTypeName(int index)
/*     */   {
/* 348 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public <T> T getValueHandler()
/*     */   {
/* 362 */     return (T)this._valueHandler;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public <T> T getTypeHandler()
/*     */   {
/* 370 */     return (T)this._typeHandler;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract String toCanonical();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getGenericSignature()
/*     */   {
/* 401 */     StringBuilder sb = new StringBuilder(40);
/* 402 */     getGenericSignature(sb);
/* 403 */     return sb.toString();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract StringBuilder getGenericSignature(StringBuilder paramStringBuilder);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getErasedSignature()
/*     */   {
/* 426 */     StringBuilder sb = new StringBuilder(40);
/* 427 */     getErasedSignature(sb);
/* 428 */     return sb.toString();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract StringBuilder getErasedSignature(StringBuilder paramStringBuilder);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected void _assertSubclass(Class<?> subclass, Class<?> superClass)
/*     */   {
/* 454 */     if (!this._class.isAssignableFrom(subclass)) {
/* 455 */       throw new IllegalArgumentException("Class " + subclass.getName() + " is not assignable to " + this._class.getName());
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract String toString();
/*     */   
/*     */ 
/*     */ 
/*     */   public abstract boolean equals(Object paramObject);
/*     */   
/*     */ 
/*     */ 
/*     */   public final int hashCode()
/*     */   {
/* 472 */     return this._hashCode;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\type\JavaType.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */