package prefuse.util;

import java.awt.BasicStroke;
import prefuse.util.collections.IntObjectHashMap;

public class StrokeLib
{
  private static final IntObjectHashMap strokeMap = new IntObjectHashMap();
  private static int misses = 0;
  private static int lookups = 0;
  public static final float[] DOTS = { 1.0F, 2.0F };
  public static final float[] DASHES = { 5.0F, 5.0F };
  public static final float[] LONG_DASHES = { 10.0F, 10.0F };
  
  public static BasicStroke getStroke(float paramFloat)
  {
    return getStroke(paramFloat, 2, 0);
  }
  
  public static BasicStroke getStroke(float paramFloat, float[] paramArrayOfFloat)
  {
    return getStroke(paramFloat, 2, 0, 10.0F, paramArrayOfFloat, 0.0F);
  }
  
  public static BasicStroke getStroke(float paramFloat, int paramInt1, int paramInt2)
  {
    return getStroke(paramFloat, paramInt1, paramInt2, 10.0F, null, 0.0F);
  }
  
  public static BasicStroke getStroke(float paramFloat1, int paramInt1, int paramInt2, float paramFloat2, float[] paramArrayOfFloat, float paramFloat3)
  {
    int i = getStrokeKey(paramFloat1, paramInt1, paramInt2, paramFloat2, paramArrayOfFloat, paramFloat3);
    BasicStroke localBasicStroke = null;
    if ((localBasicStroke = (BasicStroke)strokeMap.get(i)) == null)
    {
      localBasicStroke = new BasicStroke(paramFloat1, paramInt1, paramInt2, paramFloat2, paramArrayOfFloat, paramFloat3);
      strokeMap.put(i, localBasicStroke);
      misses += 1;
    }
    lookups += 1;
    return localBasicStroke;
  }
  
  protected static int getStrokeKey(float paramFloat1, int paramInt1, int paramInt2, float paramFloat2, float[] paramArrayOfFloat, float paramFloat3)
  {
    int i = Float.floatToIntBits(paramFloat1);
    i = i * 31 + paramInt2;
    i = i * 31 + paramInt1;
    i = i * 31 + Float.floatToIntBits(paramFloat2);
    if (paramArrayOfFloat != null)
    {
      i = i * 31 + Float.floatToIntBits(paramFloat3);
      for (int j = 0; j < paramArrayOfFloat.length; j++) {
        i = i * 31 + Float.floatToIntBits(paramArrayOfFloat[j]);
      }
    }
    return i;
  }
  
  public static BasicStroke getDerivedStroke(BasicStroke paramBasicStroke, float paramFloat)
  {
    if (paramBasicStroke.getLineWidth() == paramFloat) {
      return paramBasicStroke;
    }
    return getStroke(paramFloat * paramBasicStroke.getLineWidth(), paramBasicStroke.getEndCap(), paramBasicStroke.getLineJoin(), paramBasicStroke.getMiterLimit(), paramBasicStroke.getDashArray(), paramBasicStroke.getDashPhase());
  }
  
  public static int getCacheMissCount()
  {
    return misses;
  }
  
  public static int getCacheLookupCount()
  {
    return lookups;
  }
  
  public static void clearCache()
  {
    strokeMap.clear();
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\util\StrokeLib.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */