package prefuse.util.ui;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.Point;
import java.awt.Window;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JToolTip;
import javax.swing.Popup;
import javax.swing.PopupFactory;
import javax.swing.SwingUtilities;
import javax.swing.ToolTipManager;
import javax.swing.event.AncestorEvent;
import javax.swing.event.AncestorListener;

public class JCustomTooltip
  extends JToolTip
{
  private boolean m_persist = false;
  private Listener m_lstnr = null;
  
  public JCustomTooltip(JComponent paramJComponent1, JComponent paramJComponent2)
  {
    this(paramJComponent1, paramJComponent2, false);
  }
  
  public JCustomTooltip(JComponent paramJComponent1, JComponent paramJComponent2, boolean paramBoolean)
  {
    setLayout(new BorderLayout());
    setBorder(BorderFactory.createEmptyBorder(1, 1, 1, 1));
    setComponent(paramJComponent1);
    add(paramJComponent2);
    setPersistent(paramBoolean);
  }
  
  public boolean isPersistent()
  {
    return this.m_persist;
  }
  
  public void setPersistent(boolean paramBoolean)
  {
    if (paramBoolean == this.m_persist) {
      return;
    }
    if (paramBoolean)
    {
      this.m_lstnr = new Listener(null);
      addAncestorListener(this.m_lstnr);
    }
    else
    {
      removeAncestorListener(this.m_lstnr);
      this.m_lstnr = null;
    }
    this.m_persist = paramBoolean;
  }
  
  public void setContent(JComponent paramJComponent)
  {
    removeAll();
    add(paramJComponent);
  }
  
  public Dimension getPreferredSize()
  {
    if (getComponentCount() > 0)
    {
      Dimension localDimension = getComponent(0).getPreferredSize();
      Insets localInsets = getInsets();
      return new Dimension(localDimension.width + localInsets.left + localInsets.right, localDimension.height + localInsets.top + localInsets.bottom);
    }
    return super.getPreferredSize();
  }
  
  public void paintComponent(Graphics paramGraphics)
  {
    if (getComponentCount() > 0)
    {
      paramGraphics.setColor(getBackground());
      paramGraphics.drawRect(0, 0, getWidth() - 1, getHeight() - 1);
      paramGraphics.setColor(getComponent(0).getBackground());
      paramGraphics.fillRect(1, 1, getWidth() - 2, getHeight() - 2);
    }
  }
  
  private class Listener
    extends MouseAdapter
    implements AncestorListener
  {
    private Point point = new Point();
    private boolean showing = false;
    private Popup popup;
    
    private Listener() {}
    
    public void ancestorAdded(AncestorEvent paramAncestorEvent)
    {
      if (this.showing) {
        return;
      }
      Window localWindow1 = SwingUtilities.getWindowAncestor(JCustomTooltip.this.getParent());
      if ((localWindow1 == null) || (!localWindow1.isVisible())) {
        return;
      }
      localWindow1.getLocation(this.point);
      localWindow1.setVisible(false);
      JCustomTooltip.this.getParent().remove(JCustomTooltip.this);
      JComponent localJComponent = JCustomTooltip.this.getComponent();
      localJComponent.setToolTipText(null);
      localJComponent.removeMouseMotionListener(ToolTipManager.sharedInstance());
      this.popup = PopupFactory.getSharedInstance().getPopup(localJComponent, JCustomTooltip.this, this.point.x, this.point.y);
      Window localWindow2 = SwingUtilities.getWindowAncestor(JCustomTooltip.this);
      localWindow2.addMouseListener(this);
      localWindow2.setFocusableWindowState(true);
      this.popup.show();
      this.showing = true;
    }
    
    public void mouseEntered(MouseEvent paramMouseEvent) {}
    
    public void mouseExited(MouseEvent paramMouseEvent)
    {
      if (!this.showing) {
        return;
      }
      int i = paramMouseEvent.getX();
      int j = paramMouseEvent.getY();
      Component localComponent = (Component)paramMouseEvent.getSource();
      if ((i < 0) || (j < 0) || (i > localComponent.getWidth()) || (j > localComponent.getHeight()))
      {
        Window localWindow = SwingUtilities.getWindowAncestor(JCustomTooltip.this);
        localWindow.removeMouseListener(this);
        localWindow.setFocusableWindowState(false);
        this.popup.hide();
        this.popup = null;
        JCustomTooltip.this.getComponent().setToolTipText("?");
        this.showing = false;
      }
    }
    
    public void ancestorMoved(AncestorEvent paramAncestorEvent) {}
    
    public void ancestorRemoved(AncestorEvent paramAncestorEvent) {}
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\util\ui\JCustomTooltip.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */